/**
 * freesewing | v0.21.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
var freesewing=function(t){"use strict";function r(){this.list={}}function i(t,i){this.x=S(t),this.y=S(i),this.attributes=new r}function e(t,r){return t(r={exports:{}},r.exports),r.exports}t=t&&t.hasOwnProperty("default")?t.default:t,r.prototype.add=function(t,r){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(r),this},r.prototype.set=function(t,r){return this.list[t]=[r],this},r.prototype.remove=function(t){return delete this.list[t],this},r.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},r.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},r.prototype.render=function(){var t="";for(var r in this.list)t+=" "+r+'="'+this.list[r].join(" ")+'"';return t},r.prototype.renderAsCss=function(){var t="";for(var r in this.list)t+=" "+r+":"+this.list[r].join(" ")+";";return t},r.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",r="",i=t.length;for(var e in this.list)e.substr(0,i)===t&&(r+=" "+e.substr(i)+'="'+this.list[e].join(" ")+'"');return r},r.prototype.clone=function(){var t=new r;return t.list=JSON.parse(JSON.stringify(this.list)),t},i.prototype.rad2deg=function(t){return 57.29577951308232*t},i.prototype.deg2rad=function(t){return t/57.29577951308232},i.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},i.prototype.dist=function(t){var r=this.x-t.x,i=this.y-t.y;return S(Math.sqrt(Math.pow(r,2)+Math.pow(i,2)))},i.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},i.prototype.dx=function(t){return t.x-this.x},i.prototype.dy=function(t){return t.y-this.y},i.prototype.angle=function(t){for(var r=Math.atan2(-1*this.dy(t),this.dx(t));r<0;)r+=2*Math.PI;return this.rad2deg(r)},i.prototype.rotate=function(t,r){var e=this.dist(r),n=this.angle(r);return new i(r.x+e*Math.cos(this.deg2rad(n+t))*-1,r.y+e*Math.sin(this.deg2rad(n+t)))},i.prototype.copy=function(){return new i(this.x,this.y)},i.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new i(!1===t?-1*this.x:t.x+this.dx(t),this.y)},i.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new i(this.x,!1===t?-1*this.y:t.y+this.dy(t))},i.prototype.shift=function(t,r){var i=this.copy();return i.x+=r,i.rotate(t,this)},i.prototype.shiftTowards=function(t,r){return this.shift(this.angle(t),r)},i.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},i.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},i.prototype.shiftFractionTowards=function(t,r){return this.shiftTowards(t,this.dist(t)*r)},i.prototype.shiftOutwards=function(t,r){return this.shiftTowards(t,this.dist(t)+r)},i.prototype.clone=function(){var t=new i(this.x,this.y);return t.attributes=this.attributes.clone(),t},i.prototype.translate=function(t,r){var i=this.copy();return i.x+=t,i.y+=r,i};var n=e(function(t){var r,i,e,n,o,s,h,a,p,f,y,c,l,x;r=Math.abs,i=Math.cos,e=Math.sin,n=Math.acos,o=Math.atan2,s=Math.sqrt,h=Math.pow,a=function(t){return t<0?-h(-t,1/3):h(t,1/3)},p=Math.PI,f=2*p,y=p/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,l=Number.MIN_SAFE_INTEGER||-9007199254740991,x={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,r){var i=r(t),e=i.x*i.x+i.y*i.y;return void 0!==i.z&&(e+=i.z*i.z),s(e)},between:function(t,r,i){return r<=t&&t<=i||x.approximately(t,r)||x.approximately(t,i)},approximately:function(t,i,e){return r(t-i)<=(e||1e-6)},length:function(t){var r,i,e=0,n=x.Tvalues.length;for(r=0;r<n;r++)i=.5*x.Tvalues[r]+.5,e+=x.Cvalues[r]*x.arcfn(i,t);return.5*e},map:function(t,r,i,e,n){return e+(n-e)*((t-r)/(i-r))},lerp:function(t,r,i){var e={x:r.x+t*(i.x-r.x),y:r.y+t*(i.y-r.y)};return r.z&&i.z&&(e.z=r.z+t*(i.z-r.z)),e},pointToString:function(t){var r=t.x+"/"+t.y;return void 0!==t.z&&(r+="/"+t.z),r},pointsToString:function(t){return"["+t.map(x.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,r,i){var e=r.x-t.x,n=r.y-t.y,s=i.x-t.x,h=i.y-t.y;return o(e*h-n*s,e*s+n*h)},round:function(t,r){var i=""+t,e=i.indexOf(".");return parseFloat(i.substring(0,e+1+r))},dist:function(t,r){var i=t.x-r.x,e=t.y-r.y;return s(i*i+e*e)},closest:function(t,r){var i,e,n=h(2,63);return t.forEach(function(t,o){(e=x.dist(r,t))<n&&(n=e,i=o)}),{mdist:n,mpos:i}},abcratio:function(t,i){if(2!==i&&3!==i)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var e=h(t,i)+h(1-t,i);return r((e-1)/e)},projectionratio:function(t,r){if(2!==r&&3!==r)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=h(1-t,r);return i/(h(t,r)+i)},lli8:function(t,r,i,e,n,o,s,h){var a=(t-i)*(o-h)-(r-e)*(n-s);return 0!=a&&{x:((t*e-r*i)*(n-s)-(t-i)*(n*h-o*s))/a,y:((t*e-r*i)*(o-h)-(r-e)*(n*h-o*s))/a}},lli4:function(t,r,i,e){var n=t.x,o=t.y,s=r.x,h=r.y,a=i.x,p=i.y,u=e.x,f=e.y;return x.lli8(n,o,s,h,a,p,u,f)},lli:function(t,r){return x.lli4(t,t.c,r,r.c)},makeline:function(t,r){var i=u,e=t.x,n=t.y,o=r.x,s=r.y,h=(o-e)/3,a=(s-n)/3;return new i(e,n,e+h,n+a,e+2*h,n+2*a,o,s)},findbbox:function(t){var r=c,i=c,e=l,n=l;return t.forEach(function(t){var o=t.bbox();r>o.x.min&&(r=o.x.min),i>o.y.min&&(i=o.y.min),e<o.x.max&&(e=o.x.max),n<o.y.max&&(n=o.y.max)}),{x:{min:r,mid:(r+e)/2,max:e,size:e-r},y:{min:i,mid:(i+n)/2,max:n,size:n-i}}},shapeintersections:function(t,r,i,e,n){if(!x.bboxoverlap(r,e))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],h=[i.startcap,i.forward,i.back,i.endcap];return s.forEach(function(r){r.virtual||h.forEach(function(e){if(!e.virtual){var s=r.intersects(e,n);s.length>0&&(s.c1=r,s.c2=e,s.s1=t,s.s2=i,o.push(s))}})}),o},makeshape:function(t,r,i){var e=r.points.length,n=t.points.length,o=x.makeline(r.points[e-1],t.points[0]),s=x.makeline(t.points[n-1],r.points[0]),h={startcap:o,forward:t,back:r,endcap:s,bbox:x.findbbox([o,t,r,s])},a=x;return h.intersections=function(t){return a.shapeintersections(h,h.bbox,t,t.bbox,i)},h},getminmax:function(t,r,i){if(!i)return{min:0,max:0};var e,n,o=c,s=l;-1===i.indexOf(0)&&(i=[0].concat(i)),-1===i.indexOf(1)&&i.push(1);for(var h=0,a=i.length;h<a;h++)e=i[h],(n=t.get(e))[r]<o&&(o=n[r]),n[r]>s&&(s=n[r]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,r){var n=r.p1.x,s=r.p1.y,h=-o(r.p2.y-s,r.p2.x-n);return t.map(function(t){return{x:(t.x-n)*i(h)-(t.y-s)*e(h),y:(t.x-n)*e(h)+(t.y-s)*i(h)}})},roots:function(t,r){r=r||{p1:{x:0,y:0},p2:{x:1,y:0}};var e=t.length-1,o=x.align(t,r),h=function(t){return 0<=t&&t<=1};if(2===e){if(0!==(v=(d=o[0].y)-2*(g=o[1].y)+(m=o[2].y))){var p=-s(g*g-d*m),u=-d+g;return[-(p+u)/v,-(-p+u)/v].filter(h)}return g!==m&&0===v?[(2*g-m)/2*(g-m)].filter(h):[]}var y=o[0].y,c=o[1].y,l=o[2].y,v=3*c-y-3*l+o[3].y,d=3*y-6*c+3*l,g=-3*y+3*c,m=y;if(x.approximately(v,0)){if(x.approximately(d,0))return x.approximately(g,0)?[]:[-m/g].filter(h);var w=2*d;return[((b=s(g*g-4*d*m))-g)/w,(-g-b)/w].filter(h)}var b,z,S=(o=(3*(g/=v)-(d/=v)*d)/3)/3,_=(b=(2*d*d*d-9*d*g+27*(m/=v))/27)/2,O=_*_+S*S*S;if(O<0){var M=-o/3,k=s(M*M*M),P=-b/(2*k),R=n(P<-1?-1:P>1?1:P),L=2*a(k);return[L*i(R/3)-d/3,L*i((R+f)/3)-d/3,L*i((R+2*f)/3)-d/3].filter(h)}if(0===O)return[2*(z=_<0?a(-_):-a(_))-d/3,-z-d/3].filter(h);var I=s(O);return[(z=a(-_+I))-a(_+I)-d/3].filter(h)},droots:function(t){if(3===t.length){var r=t[0],i=t[1],e=t[2],n=r-2*i+e;if(0!==n){var o=-s(i*i-r*e),h=-r+i;return[-(o+h)/n,-(-o+h)/n]}return i!==e&&0===n?[(2*i-e)/(2*(i-e))]:[]}if(2===t.length)return(r=t[0])!==(i=t[1])?[r/(r-i)]:[]},inflections:function(t){if(t.length<4)return[];var r=x.align(t,{p1:t[0],p2:t.slice(-1)[0]}),i=r[2].x*r[1].y,e=r[3].x*r[1].y,n=r[1].x*r[2].y,o=18*(-3*i+2*e+3*n-(f=r[3].x*r[2].y)),s=18*(3*i-e-3*n),h=18*(n-i);if(x.approximately(o,0)){if(!x.approximately(s,0)){var a=-h/s;if(0<=a&&a<=1)return[a]}return[]}var p=s*s-4*o*h,u=Math.sqrt(p),f=2*o;return x.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,i){var e,n,o,s,h,a=["x","y"],p=a.length;for(e=0;e<p;e++)if(o=t[n=a[e]].mid,s=i[n].mid,h=(t[n].size+i[n].size)/2,r(o-s)>=h)return!1;return!0},expandbox:function(t,r){r.x.min<t.x.min&&(t.x.min=r.x.min),r.y.min<t.y.min&&(t.y.min=r.y.min),r.z&&r.z.min<t.z.min&&(t.z.min=r.z.min),r.x.max>t.x.max&&(t.x.max=r.x.max),r.y.max>t.y.max&&(t.y.max=r.y.max),r.z&&r.z.max>t.z.max&&(t.z.max=r.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,r,i){var e=t.bbox(),n=r.bbox(),o=1e5,s=i||.5;if(e.x.size+e.y.size<s&&n.x.size+n.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(r._t1+r._t2)/2|0)/o];var h=t.split(.5),a=r.split(.5),p=[{left:h.left,right:a.left},{left:h.left,right:a.right},{left:h.right,right:a.right},{left:h.right,right:a.left}];p=p.filter(function(t){return x.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===p.length?u:(p.forEach(function(t){u=u.concat(x.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,r){return u.indexOf(t)===r}))},getccenter:function(t,r,n){var s,h=r.x-t.x,a=r.y-t.y,p=n.x-r.x,u=n.y-r.y,c=h*i(y)-a*e(y),l=h*e(y)+a*i(y),v=p*i(y)-u*e(y),d=p*e(y)+u*i(y),g=(t.x+r.x)/2,m=(t.y+r.y)/2,w=(r.x+n.x)/2,b=(r.y+n.y)/2,z=g+c,S=m+l,_=w+v,O=b+d,M=x.lli8(g,m,z,S,w,b,_,O),k=x.dist(M,t),P=o(t.y-M.y,t.x-M.x),R=o(r.y-M.y,r.x-M.x),L=o(n.y-M.y,n.x-M.x);return P<L?((P>R||R>L)&&(P+=f),P>L&&(s=L,L=P,P=s)):L<R&&R<P?(s=L,L=P,P=s):L+=f,M.s=P,M.e=L,M.r=k,M},numberSort:function(t,r){return t-r}},t.exports=x}),o=e(function(t){var r,i;r=n,(i=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return r.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,r){return t+r})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,i=t[0].bbox(),e=1;e<t.length;e++)r.expandbox(i,t[e].bbox());return i},offset:function(t){var r=[];return this.curves.forEach(function(i){r=r.concat(i.offset(t))}),new i(r)}},t.exports=i});var s=function(t){var r,i,e,n,o,s,h=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),a=h.length,p=[],u=0,f=0,y=0,c=0,l=0,x=0,v=0,d=0,g="";for(r=1;r<a;r++)if(n=(e=(i=h[r]).substring(0,1)).toLowerCase(),o=(p=(p=i.replace(e,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===n){if(g+="M ","m"===e?(y+=p[0],c+=p[1]):(y=p[0],c=p[1]),u=y,f=c,g+=y+" "+c+" ",o>2)for(s=0;s<o;s+=2)"m"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ")}else if("l"===n)for(s=0;s<o;s+=2)"l"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ");else if("h"===n)for(s=0;s<o;s++)"h"===e?y+=p[s]:y=p[s],g+=["L",y,c,""].join(" ");else if("v"===n)for(s=0;s<o;s++)"v"===e?c+=p[s]:c=p[s],g+=["L",y,c,""].join(" ");else if("q"===n)for(s=0;s<o;s+=4)"q"===e?(l=y+p[s],x=c+p[s+1],y+=p[s+2],c+=p[s+3]):(l=p[s],x=p[s+1],y=p[s+2],c=p[s+3]),g+=["Q",l,x,y,c,""].join(" ");else if("t"===n)for(s=0;s<o;s+=2)l=y+(y-l),x=c+(c-x),"t"===e?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["Q",l,x,y,c,""].join(" ");else if("c"===n)for(s=0;s<o;s+=6)"c"===e?(l=y+p[s],x=c+p[s+1],v=y+p[s+2],d=c+p[s+3],y+=p[s+4],c+=p[s+5]):(l=p[s],x=p[s+1],v=p[s+2],d=p[s+3],y=p[s+4],c=p[s+5]),g+=["C",l,x,v,d,y,c,""].join(" ");else if("s"===n)for(s=0;s<o;s+=4)l=y+(y-v),x=c+(c-d),"s"===e?(v=y+p[s],d=c+p[s+1],y+=p[s+2],c+=p[s+3]):(v=p[s],d=p[s+1],y=p[s+2],c=p[s+3]),g+=["C",l,x,v,d,y,c,""].join(" ");else"z"===n&&(g+="Z ",y=u,c=f);return g.trim()},h={x:!1,y:!1};function a(t,r,i){if("Z"!==r){if("M"!==r){var e=[!1,h.x,h.y].concat(i),n=new(t.bind.apply(t,e)),o=i.slice(-2);return h={x:o[0],y:o[1]},n}h={x:i[0],y:i[1]}}}var p=function(t,r){for(var i,e,n=s(r).split(" "),o=new RegExp("[MLCQZ]",""),h=[],p={C:6,Q:4,L:2,M:2};n.length;)i=n.splice(0,1)[0],o.test(i)&&(e=a(t,i,n.splice(0,p[i]).map(parseFloat)))&&h.push(e);return new t.PolyBezier(h)},u=e(function(t){!function(){var r=Math.abs,i=Math.min,e=Math.max,s=Math.cos,h=Math.sin,a=Math.acos,u=Math.sqrt,f=Math.PI,y={x:0,y:0,z:0},c=n,l=o,x=function(t){var i=t&&t.forEach?t:[].slice.call(arguments),e=!1;if("object"==typeof i[0]){e=i.length;var n=[];i.forEach(function(t){["x","y","z"].forEach(function(r){void 0!==t[r]&&n.push(t[r])})}),i=n}var o=!1,s=i.length;if(e){if(e>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var h=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=h;for(var a=[],p=0,u=h?3:2;p<s;p+=u){var f={x:i[p],y:i[p+1]};h&&(f.z=i[p+2]),a.push(f)}this.order=a.length-1,this.points=a;var y=["x","y"];h&&y.push("z"),this.dims=y,this.dimlen=y.length,function(t){for(var i=t.order,e=t.points,n=c.align(e,{p1:e[0],p2:e[i]}),o=0;o<n.length;o++)if(r(n[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},v=p;function d(t,r,i,e,n){void 0===n&&(n=.5);var o=c.projectionratio(n,t),s=1-o,h={x:o*r.x+s*e.x,y:o*r.y+s*e.y},a=c.abcratio(n,t);return{A:{x:i.x+(i.x-h.x)/a,y:i.y+(i.y-h.y)/a},B:i,C:h}}x.SVGtoBeziers=function(t){return v(x,t)},x.quadraticFromPoints=function(t,r,i,e){if(void 0===e&&(e=.5),0===e)return new x(r,r,i);if(1===e)return new x(t,r,r);var n=d(2,t,r,i,e);return new x(t,n.A,i)},x.cubicFromPoints=function(t,r,i,e,n){void 0===e&&(e=.5);var o=d(3,t,r,i,e);void 0===n&&(n=c.dist(r,o.C));var s=n*(1-e)/e,h=c.dist(t,i),a=(i.x-t.x)/h,p=(i.y-t.y)/h,u=n*a,f=n*p,y=s*a,l=s*p,v=r.x-u,g=r.y-f,m=r.x+y,w=r.y+l,b=o.A,z=b.x+(v-b.x)/(1-e),S=b.y+(g-b.y)/(1-e),_=b.x+(m-b.x)/e,O=b.y+(w-b.y)/e,M={x:t.x+(z-t.x)/e,y:t.y+(S-t.y)/e},k={x:i.x+(_-i.x)/(1-e),y:i.y+(O-i.y)/(1-e)};return new x(t,M,k,i)};var g=function(){return c};x.getUtils=g,x.PolyBezier=l,x.prototype={getUtils:g,valueOf:function(){return this.toString()},toString:function(){return c.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var r=this.points,i=["M",r[0].x,r[0].y,2===this.order?"Q":"C"],e=1,n=r.length;e<n;e++)i.push(r[e].x),i.push(r[e].y);return i.join(" ")},update:function(){this.dpoints=[];for(var t=this.points,r=t.length,i=r-1;r>1;r--,i--){for(var e,n=[],o=0;o<i;o++)e={x:i*(t[o+1].x-t[o].x),y:i*(t[o+1].y-t[o].y)},this._3d&&(e.z=i*(t[o+1].z-t[o].z)),n.push(e);this.dpoints.push(n),t=n}this.computedirection()},computedirection:function(){var t=this.points,r=c.angle(t[0],t[this.order],t[1]);this.clockwise=r>0},length:function(){return c.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var r=0;r<=t;r++)this._lut.push(this.compute(r/t));return this._lut},on:function(t,r){r=r||5;for(var i,e=this.getLUT(),n=[],o=0,s=0;s<e.length;s++)i=e[s],c.dist(i,t)<r&&(n.push(i),o+=s/e.length);return!!n.length&&o/n.length},project:function(t){var r=this.getLUT(),i=r.length-1,e=c.closest(r,t),n=e.mdist,o=e.mpos;if(0===o||o===i){var s=o/i,h=this.compute(s);return h.t=s,h.d=n,h}var a,p,u,f=(o+1)/i,y=.1/i;for(n+=1,a=s=(o-1)/i;s<f+y;s+=y)p=this.compute(s),(u=c.dist(t,p))<n&&(n=u,a=s);return(p=this.compute(a)).t=a,p.d=n,p},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){if(0===t)return this.points[0];if(1===t)return this.points[this.order];var r=this.points,i=1-t;if(1===this.order)return p={x:i*r[0].x+t*r[1].x,y:i*r[0].y+t*r[1].y},this._3d&&(p.z=i*r[0].z+t*r[1].z),p;if(this.order<4){var e,n,o,s=i*i,h=t*t,a=0;2===this.order?(r=[r[0],r[1],r[2],y],e=s,n=i*t*2,o=h):3===this.order&&(e=s*i,n=s*t*3,o=i*h*3,a=t*h);var p={x:e*r[0].x+n*r[1].x+o*r[2].x+a*r[3].x,y:e*r[0].y+n*r[1].y+o*r[2].y+a*r[3].y};return this._3d&&(p.z=e*r[0].z+n*r[1].z+o*r[2].z+a*r[3].z),p}for(var u=JSON.parse(JSON.stringify(this.points));u.length>1;){for(var f=0;f<u.length-1;f++)u[f]={x:u[f].x+(u[f+1].x-u[f].x)*t,y:u[f].y+(u[f+1].y-u[f].y)*t},void 0!==u[f].z&&(u[f]=u[f].z+(u[f+1].z-u[f].z)*t);u.splice(u.length-1,1)}return u[0]},raise:function(){for(var t,r,i=this.points,e=[i[0]],n=i.length,o=1;o<n;o++)t=i[o],r=i[o-1],e[o]={x:(n-o)/n*t.x+o/n*r.x,y:(n-o)/n*t.y+o/n*r.y};return e[n]=i[n-1],new x(e)},derivative:function(t){var r,i,e=1-t,n=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],y],r=e,i=t),3===this.order&&(r=e*e,i=e*t*2,n=t*t);var s={x:r*o[0].x+i*o[1].x+n*o[2].x,y:r*o[0].y+i*o[1].y+n*o[2].y};return this._3d&&(s.z=r*o[0].z+i*o[1].z+n*o[2].z),s},inflections:function(){return c.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var r=this.derivative(t),i=u(r.x*r.x+r.y*r.y);return{x:-r.y/i,y:r.x/i}},__normal3:function(t){var r=this.derivative(t),i=this.derivative(t+.01),e=u(r.x*r.x+r.y*r.y+r.z*r.z),n=u(i.x*i.x+i.y*i.y+i.z*i.z);r.x/=e,r.y/=e,r.z/=e,i.x/=n,i.y/=n,i.z/=n;var o={x:i.y*r.z-i.z*r.y,y:i.z*r.x-i.x*r.z,z:i.x*r.y-i.y*r.x},s=u(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var h=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:h[0]*r.x+h[1]*r.y+h[2]*r.z,y:h[3]*r.x+h[4]*r.y+h[5]*r.z,z:h[6]*r.x+h[7]*r.y+h[8]*r.z}},hull:function(t){var r,i=this.points,e=[],n=[],o=0,s=0,h=0;for(n[o++]=i[0],n[o++]=i[1],n[o++]=i[2],3===this.order&&(n[o++]=i[3]);i.length>1;){for(e=[],s=0,h=i.length-1;s<h;s++)r=c.lerp(t,i[s],i[s+1]),n[o++]=r,e.push(r);i=e}return n},split:function(t,r){if(0===t&&r)return this.split(r).left;if(1===r)return this.split(t).right;var i=this.hull(t),e={left:2===this.order?new x([i[0],i[3],i[5]]):new x([i[0],i[4],i[7],i[9]]),right:2===this.order?new x([i[5],i[4],i[2]]):new x([i[9],i[8],i[6],i[3]]),span:i};return e.left._t1=c.map(0,0,1,this._t1,this._t2),e.left._t2=c.map(t,0,1,this._t1,this._t2),e.right._t1=c.map(t,0,1,this._t1,this._t2),e.right._t2=c.map(1,0,1,this._t1,this._t2),r?(r=c.map(r,t,1,0,1),e.right.split(r).left):e},extrema:function(){var t,r,i=this.dims,e={},n=[];return i.forEach(function(i){r=function(t){return t[i]},t=this.dpoints[0].map(r),e[i]=c.droots(t),3===this.order&&(t=this.dpoints[1].map(r),e[i]=e[i].concat(c.droots(t))),e[i]=e[i].filter(function(t){return t>=0&&t<=1}),n=n.concat(e[i].sort(c.numberSort))}.bind(this)),n=n.sort(c.numberSort).filter(function(t,r){return n.indexOf(t)===r}),e.values=n,e},bbox:function(){var t=this.extrema(),r={};return this.dims.forEach(function(i){r[i]=c.getminmax(this,i,t[i])}.bind(this)),r},overlaps:function(t){var r=this.bbox(),i=t.bbox();return c.bboxoverlap(r,i)},offset:function(t,r){if(void 0!==r){var i=this.get(t),e=this.normal(t),n={c:i,n:e,x:i.x+e.x*r,y:i.y+e.y*r};return this._3d&&(n.z=i.z+e.z*r),n}if(this._linear){var o=this.normal(0),s=this.points.map(function(r){var i={x:r.x+t*o.x,y:r.y+t*o.y};return r.z&&e.z&&(i.z=r.z+t*o.z),i});return[new x(s)]}return this.reduce().map(function(r){return r.scale(t)})},simple:function(){if(3===this.order){var t=c.angle(this.points[0],this.points[3],this.points[1]),i=c.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&i<0||t<0&&i>0)return!1}var e=this.normal(0),n=this.normal(1),o=e.x*n.x+e.y*n.y;return this._3d&&(o+=e.z*n.z),r(a(o))<f/3},reduce:function(){var t,i,e=0,n=0,o=[],s=[],h=this.extrema().values;for(-1===h.indexOf(0)&&(h=[0].concat(h)),-1===h.indexOf(1)&&h.push(1),e=h[0],t=1;t<h.length;t++)n=h[t],(i=this.split(e,n))._t1=e,i._t2=n,o.push(i),e=n;return o.forEach(function(t){for(e=0,n=0;n<=1;)for(n=e+.01;n<=1.01;n+=.01)if(!(i=t.split(e,n)).simple()){if(r(e-(n-=.01))<.01)return[];(i=t.split(e,n))._t1=c.map(e,0,1,t._t1,t._t2),i._t2=c.map(n,0,1,t._t1,t._t2),s.push(i),e=n;break}e<1&&((i=t.split(e,1))._t1=c.map(e,0,1,t._t1,t._t2),i._t2=t._t2,s.push(i))}),s},scale:function(t){var r=this.order,i=!1;if("function"==typeof t&&(i=t),i&&2===r)return this.raise().scale(i);var e=this.clockwise,n=i?i(0):t,o=i?i(1):t,s=[this.offset(0,10),this.offset(1,10)],h=c.lli4(s[0],s[0].c,s[1],s[1].c);if(!h)throw new Error("cannot scale this curve. Try reducing it first.");var a=this.points,p=[];return[0,1].forEach(function(t){var i=p[t*r]=c.copy(a[t*r]);i.x+=(t?o:n)*s[t].n.x,i.y+=(t?o:n)*s[t].n.y}.bind(this)),i?([0,1].forEach(function(n){if(2!==this.order||!n){var o=a[n+1],s={x:o.x-h.x,y:o.y-h.y},f=i?i((n+1)/r):t;i&&!e&&(f=-f);var y=u(s.x*s.x+s.y*s.y);s.x/=y,s.y/=y,p[n+1]={x:o.x+f*s.x,y:o.y+f*s.y}}}.bind(this)),new x(p)):([0,1].forEach(function(t){if(2!==this.order||!t){var i=p[t*r],e=this.derivative(t),n={x:i.x+e.x,y:i.y+e.y};p[t+1]=c.lli4(i,n,h,a[t+1])}}.bind(this)),new x(p))},outline:function(t,r,i,e){r=void 0===r?t:r;var n,o=this.reduce(),s=o.length,h=[],a=[],p=0,u=this.length(),f=void 0!==i&&void 0!==e;function y(t,r,i,e,n){return function(o){var s=e/i,h=(e+n)/i,a=r-t;return c.map(o,0,1,t+s*a,t+h*a)}}o.forEach(function(n){z=n.length(),f?(h.push(n.scale(y(t,i,u,p,z))),a.push(n.scale(y(-r,-e,u,p,z)))):(h.push(n.scale(t)),a.push(n.scale(-r))),p+=z}),a=a.map(function(t){return(n=t.points)[3]?t.points=[n[3],n[2],n[1],n[0]]:t.points=[n[2],n[1],n[0]],t}).reverse();var x=h[0].points[0],v=h[s-1].points[h[s-1].points.length-1],d=a[s-1].points[a[s-1].points.length-1],g=a[0].points[0],m=c.makeline(d,x),w=c.makeline(v,g),b=[m].concat(h).concat([w]).concat(a),z=b.length;return new l(b)},outlineshapes:function(t,r,i){r=r||t;for(var e=this.outline(t,r).curves,n=[],o=1,s=e.length;o<s/2;o++){var h=c.makeshape(e[o],e[s-o],i);h.startcap.virtual=o>1,h.endcap.virtual=o<s/2-1,n.push(h)}return n},intersects:function(t,r){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof x&&(t=t.reduce()),this.curveintersects(this.reduce(),t,r)):this.selfintersects(r)},lineIntersects:function(t){var r=i(t.p1.x,t.p2.x),n=i(t.p1.y,t.p2.y),o=e(t.p1.x,t.p2.x),s=e(t.p1.y,t.p2.y),h=this;return c.roots(this.points,t).filter(function(t){var i=h.get(t);return c.between(i.x,r,o)&&c.between(i.y,n,s)})},selfintersects:function(t){var r,i,e,n,o=this.reduce(),s=o.length-2,h=[];for(r=0;r<s;r++)e=o.slice(r,r+1),n=o.slice(r+2),i=this.curveintersects(e,n,t),h=h.concat(i);return h},curveintersects:function(t,r,i){var e=[];t.forEach(function(t){r.forEach(function(r){t.overlaps(r)&&e.push({left:t,right:r})})});var n=[];return e.forEach(function(t){var r=c.pairiteration(t.left,t.right,i);r.length>0&&(n=n.concat(r))}),n},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,i,e,n){var o=(n-e)/4,s=this.get(e+o),h=this.get(n-o),a=c.dist(t,i),p=c.dist(t,s),u=c.dist(t,h);return r(p-a)+r(u-a)},_iterate:function(t,r){var i,e=0,n=1;do{i=0,n=1;var o,a,p,u,f,y=this.get(e),l=!1,x=!1,v=n,d=1;do{if(x=l,u=p,v=(e+n)/2,o=this.get(v),a=this.get(n),(p=c.getccenter(y,o,a)).interval={start:e,end:n},l=this._error(p,y,e,n)<=t,(f=x&&!l)||(d=n),l){if(n>=1){if(p.interval.end=d=1,u=p,n>1){var g={x:p.x+p.r*s(p.e),y:p.y+p.r*h(p.e)};p.e+=c.angle({x:p.x,y:p.y},g,this.get(1))}break}n+=(n-e)/2}else n=v}while(!f&&i++<100);if(i>=100)break;u=u||p,r.push(u),e=d}while(n<1);return r}},t.exports=x}()}),f=u;function y(t){return"_macro_"+t}function c(t,r,e,n){var o=t.slope(r),s=e.slope(n);if(o===s)return!1;if(t.x===r.x)return new i(t.x,s*t.x+(e.y-s*e.x));if(e.x===n.x)return new i(e.x,o*e.x+(t.y-o*t.x));t.x>r.x&&(t=r.copy()),e.x>n.x&&(e=n.copy());var h=t.y-o*t.x,a=(e.y-s*e.x-h)/(o-s);return new i(a,o*a+h)}function l(t,r,i,e){var n=c(t,r,i,e);if(!n)return!1;var o=t.dist(r),s=i.dist(e),h=t.dist(n)+n.dist(r),a=i.dist(n)+n.dist(e);return Math.round(o)==Math.round(h)&&Math.round(s)==Math.round(a)&&n}function x(t,r,i){var e=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(i))return!0;if(r.sitsOn(i))return!0;var n=i.dx(t)*r.dy(t)-i.dy(t)*r.dx(t);return 0===Math.abs(Math.round(n*e)/e)}function v(t,r,i){if(!x(t,r,i,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var e=t.dist(r),n=t.dist(i)+i.dist(r);return Math.round(e)==Math.round(n)}function d(t,r,i,e,n){if(t.sitsOn(n))return!0;if(e.sitsOn(n))return!0;var o=new f({x:t.x,y:t.y},{x:r.x,y:r.y},{x:i.x,y:i.y},{x:e.x,y:e.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function g(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?S(t/25.4)+'"':S(t/10)+"cm"}function m(t,r,e,n,o,s){var h=[],a=new f({x:e.x,y:e.y},{x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y}),p={p1:{x:t.x,y:t.y},p2:{x:r.x,y:r.y}},u=!0,y=!1,c=void 0;try{for(var l,x=a.intersects(p)[Symbol.iterator]();!(u=(l=x.next()).done);u=!0){var v=l.value,d=a.get(v);h.push(new i(d.x,d.y))}}catch(t){y=!0,c=t}finally{try{!u&&x.return&&x.return()}finally{if(y)throw c}}return 0!==h.length&&(1===h.length?h[0]:h)}function w(t,r,e,n,o,s,h,a){var p=[],u=new f({x:t.x,y:t.y},{x:r.x,y:r.y},{x:e.x,y:e.y},{x:n.x,y:n.y}),y=new f({x:o.x,y:o.y},{x:s.x,y:s.y},{x:h.x,y:h.y},{x:a.x,y:a.y}),c=!0,l=!1,x=void 0;try{for(var v,d=u.intersects(y,.005)[Symbol.iterator]();!(c=(v=d.next()).done);c=!0){var g=v.value,m=u.get(g.substr(0,g.indexOf("/")));p.push(new i(m.x,m.y))}}catch(t){l=!0,x=t}finally{try{!c&&d.return&&d.return()}finally{if(l)throw x}}if(0===p.length)return!1;if(1===p.length)return p.shift();var w=[],b=!0,z=!1,S=void 0;try{for(var _,O=p[Symbol.iterator]();!(b=(_=O.next()).done);b=!0){var M=_.value,k=!1,P=!0,R=!1,L=void 0;try{for(var I,j=w[Symbol.iterator]();!(P=(I=j.next()).done);P=!0){var T=I.value;M.sitsRoughlyOn(T)&&(k=!0)}}catch(t){R=!0,L=t}finally{try{!P&&j.return&&j.return()}finally{if(R)throw L}}k||w.push(M)}}catch(t){z=!0,S=t}finally{try{!b&&O.return&&O.return()}finally{if(z)throw S}}return w}function b(t,r,e,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=n.x-e.x,h=n.y-e.y,a=Math.pow(s,2)+Math.pow(h,2),p=2*(s*(e.x-t.x)+h*(e.y-t.y)),u=Math.pow(e.x-t.x,2)+Math.pow(e.y-t.y,2)-Math.pow(r,2),f=Math.pow(p,2)-4*a*u;if(a<=1e-7||f<0)return!1;if(0===f){var y=-1*p/(2*a);return[new i(e.x+y*s,e.y+y*h)]}var c=(-1*p+Math.sqrt(f))/(2*a),l=new i(e.x+c*s,e.y+c*h);c=(-1*p-Math.sqrt(f))/(2*a);var x=new i(e.x+c*s,e.y+c*h);return"x"===o&&l.x<=x.x||"y"===o&&l.y<=x.y?[l,x]:[x,l]}function z(t,r){var e=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,n=1/0,o=1/0,s=void 0;"bottom"===r&&(o=-1/0),"right"===r&&(n=-1/0);for(var h=0;h<e;h++)s=t.get(h/e),("top"===r&&s.y<o||"bottom"===r&&s.y>o||"right"===r&&s.x>n||"left"===r&&s.x<n)&&(n=s.x,o=s.y);return new i(n,o)}function S(t){return Math.round(100*t)/100}function _(t,r){return"stroke: hsl("+330/r*(t-1)+", 100%, 35%);"}var O=Object.freeze({macroName:y,beamsIntersect:c,linesIntersect:l,pointOnBeam:x,pointOnLine:v,pointOnCurve:d,beamIntersectsX:function(t,r,e){return t.x!==r.x&&c(t,r,new i(e,-10),new i(e,10))},beamIntersectsY:function(t,r,e){return t.y!==r.y&&c(t,r,new i(-10,e),new i(10,e))},units:g,lineIntersectsCurve:m,curvesIntersect:w,circlesIntersect:function(t,r,e,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=t.dx(e),h=t.dy(e),a=t.dist(e);if(a>parseFloat(r)+parseFloat(n))return!1;if(a<parseFloat(n)-parseFloat(r))return!1;if(0===a&&r===n)return!1;var p=(Math.pow(r,2)-Math.pow(n,2)+Math.pow(a,2))/(2*a),u=Math.sqrt(Math.pow(r,2)-Math.pow(p,2)),f=t.x+p*s/a,y=t.y+p*h/a,c=new i(f+u*h/a,y-u*s/a),l=new i(f-u*h/a,y+u*s/a);return"x"===o&&c.x<=l.x||"y"===o&&c.y<=l.y?[c,l]:[l,c]},beamIntersectsCircle:b,lineIntersectsCircle:function(t,r,i,e){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=b(t,r,i,e,n);if(!1===o)return!1;if(1===o.length)return!!v(i,e,o[0])&&o;var s=o[0],h=o[1];return!(!v(i,e,s,5)&&!v(i,e,h,5))&&(v(i,e,s,5)&&v(i,e,h,5)?"x"===n&&s.x<=h.x||"y"===n&&s.y<=h.y?[s,h]:[h,s]:v(i,e,s,5)?[s]:v(i,e,h,5)?[h]:void 0)},curveEdge:z,stretchToScale:function(t){return 1/(1+parseFloat(t))},round:S,sampleStyle:_}),M="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},k=Object.assign||function(t){for(var r=1;r<arguments.length;r++){var i=arguments[r];for(var e in i)Object.prototype.hasOwnProperty.call(i,e)&&(t[e]=i[e])}return t};function P(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new r,this.ops=[]}function R(t,r,i){if(t.x===r.x&&t.y===r.y)return!1;var e=t.angle(r)-90;return(new P).move(t.shift(e,i)).line(r.shift(e,i))}function L(t){return(new P).move(new i(t.points[0].x,t.points[0].y)).curve(new i(t.points[1].x,t.points[1].y),new i(t.points[2].x,t.points[2].y),new i(t.points[3].x,t.points[3].y))}function I(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=(new P).move(t[0].ops[0].to),e=void 0,n=!0,o=!1,s=void 0;try{for(var h,a=t[Symbol.iterator]();!(n=(h=a.next()).done);n=!0){var p=h.value,u=!0,f=!1,y=void 0;try{for(var c,l=p.ops[Symbol.iterator]();!(u=(c=l.next()).done);u=!0){var x=c.value;if("curve"===x.type)i.curve(x.cp1,x.cp2,x.to);else{if("close"===x.type)throw"Cannot join a closed paths with another";e&&!x.to.sitsRoughlyOn(e)&&i.line(x.to)}x.to&&(e=x.to)}}catch(t){f=!0,y=t}finally{try{!u&&l.return&&l.return()}finally{if(f)throw y}}}}catch(t){o=!0,s=t}finally{try{!n&&a.return&&a.return()}finally{if(o)throw s}}return r&&i.close(),i}function j(t,r){for(var e=void 0,n=void 0,o=void 0,s=void 0,h=0,a=0;a<=100;a++){if(o=a/100,n=new i((n=r.get(o)).x,n.y),a>0){if(h+(s=n.dist(e))>t)return n;h+=s}e=n}}function T(t){var r=t.from,e=t.to;return r.x===e.x?r.y<e.y?{topLeft:r,bottomRight:e}:{topLeft:e,bottomRight:r}:r.y===e.y?r.x<e.x?{topLeft:r,bottomRight:e}:{topLeft:e,bottomRight:r}:r.x<e.x?r.y<e.y?{topLeft:r,bottomRight:e}:{topLeft:new i(r.x,e.y),bottomRight:new i(e.x,r.y)}:r.x>e.x?r.y<e.y?{topLeft:new i(e.x,r.y),bottomRight:new i(r.x,e.y)}:{topLeft:new i(e.x,e.y),bottomRight:new i(r.x,r.y)}:void 0}function C(t,r){if(t&&"object"===(void 0===t?"undefined":M(t)))if("number"==typeof t.x)r.push(t);else{var i=!0,e=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var h=o.value;r.push(h)}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}}}function E(t,i){return this.def=t,this.anchor=i,this.attributes=new r,this}function A(){return this.attributes=new r,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=O,this.Point=i,this.Path=P,this.Snippet=E,this}P.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},P.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},P.prototype.curve=function(t,r,i){return this.ops.push({type:"curve",cp1:t,cp2:r,to:i}),this},P.prototype.close=function(){return this.ops.push({type:"close"}),this},P.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},P.prototype.asPathstring=function(){var t="",r=!0,i=!1,e=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}return t},P.prototype.offset=function(t){return function(t,r){var i=[],e=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var h=R(e,s.to,r);h&&i.push(h)}else if("curve"===s.type){var a=void 0,p=void 0;a=e.sitsRoughlyOn(s.cp1)?(new P).move(e).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new P).move(s.to).curve(s.cp2,s.cp1,e).shiftAlong(2):s.cp2;var u=new f({x:e.x,y:e.y},{x:a.x,y:a.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),y=!0,c=!1,l=void 0;try{for(var x,v=u.offset(r)[Symbol.iterator]();!(y=(x=v.next()).done);y=!0){var d=x.value;i.push(L(d))}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}else"close"===s.type&&(n=!0);s.to&&(e=s.to)}return I(i,n)}(this,t)},P.prototype.length=function(){var t=void 0,r=void 0,i=0;for(var e in this.ops){var n=this.ops[e];"move"===n.type?r=n.to:"line"===n.type?i+=t.dist(n.to):"curve"===n.type?i+=new f({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(i+=t.dist(r)),n.to&&(t=n.to)}return S(i)},P.prototype.start=function(){return this.ops[0].to},P.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},P.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,r=new i(1/0,1/0),e=new i(-1/0,-1/0),n=[];for(var o in this.ops){var s=this.ops[o];if("move"===s.type||"line"===s.type)s.to.x<r.x&&(r.x=s.to.x,n.leftOp=o),s.to.y<r.y&&(r.y=s.to.y,n.topOp=o),s.to.x>e.x&&(e.x=s.to.x,n.rightOp=o),s.to.y>e.y&&(e.y=s.to.y,n.bottomOp=o);else if("curve"===s.type){var h=new f({x:t.x,y:t.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}).bbox();h.x.min<r.x&&(r.x=h.x.min,n.leftOp=o),h.y.min<r.y&&(r.y=h.y.min,n.topOp=o),h.x.max>e.x&&(e.x=h.x.max,n.rightOp=o),h.y.max>e.y&&(e.y=h.y.max,n.bottomOp=o)}s.to&&(t=s.to)}this.topLeft=r,this.bottomRight=e;for(var a=["top","left","bottom","right"],p=0;p<a.length;p++){var u=a[p]+"Op";this[u]=this.ops[n[u]],this[u].from="move"===this[u].type?this[u].to:this.ops[n[u]-1].to}return this},P.prototype.clone=function(){var t=new P;for(var r in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var i=this.ops[r];t.ops[r]={type:i.type},"move"===i.type||"line"===i.type?t.ops[r].to=i.to.clone():"curve"===i.type&&(t.ops[r].to=i.to.clone(),t.ops[r].cp1=i.cp1.clone(),t.ops[r].cp2=i.cp2.clone())}return t},P.prototype.join=function(t){return I([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},P.prototype.shiftAlong=function(t){var r=0,i=void 0;for(var e in this.ops){var n=this.ops[e];if("line"===n.type){var o=n.to.dist(i);if(r+o>t)return i.shiftTowards(n.to,t-r);r+=o}else if("curve"===n.type){var s=new f({x:i.x,y:i.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),h=s.length();if(r+h>t)return j(t-r,s);r+=h}i=n.to}throw"Ran out of path to shift along"},P.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},P.prototype.bbox=function(){var t,r,e=[],n=void 0;for(var o in this.ops){var s=this.ops[o];"line"===s.type?e.push(T({from:n,to:s.to})):"curve"===s.type&&e.push((t=new f({x:n.x,y:n.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}),void 0,{topLeft:new i((r=t.bbox()).x.min,r.y.min),bottomRight:new i(r.x.max,r.y.max)})),s.to&&(n=s.to)}return function(t){var r=1/0,e=-1/0,n=1/0,o=-1/0,s=!0,h=!1,a=void 0;try{for(var p,u=t[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;f.topLeft.x<r&&(r=f.topLeft.x),f.topLeft.y<n&&(n=f.topLeft.y),f.bottomRight.x>e&&(e=f.bottomRight.x),f.bottomRight.y>o&&(o=f.bottomRight.y)}}catch(t){h=!0,a=t}finally{try{!s&&u.return&&u.return()}finally{if(h)throw a}}return{topLeft:new i(r,n),bottomRight:new i(e,o)}}(e)},P.prototype.reverse=function(){var t=[],r=void 0,i=!1;for(var e in this.ops){var n=this.ops[e];"line"===n.type?n.to.sitsOn(r)||t.push((new P).move(n.to).line(r)):"curve"===n.type?t.push((new P).move(n.to).curve(n.cp2,n.cp1,r)):"close"===n.type&&(i=!0),n.to&&(r=n.to)}var o=(new P).move(r),s=!0,h=!1,a=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;o.ops.push(f.ops[1])}}catch(t){h=!0,a=t}finally{try{!s&&u.return&&u.return()}finally{if(h)throw a}}return i&&o.close(),o},P.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new i(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new i(this.topLeft.x,this.bottomRight.y);var r,e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return z((r=this[e],new f({x:r.from.x,y:r.from.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y})),t)}},P.prototype.divide=function(){var t=[],r=void 0,i=void 0;for(var e in this.ops){var n=this.ops[e];"move"===n.type?i=n.to:"line"===n.type?n.to.sitsRoughlyOn(r)||t.push((new P).move(r).line(n.to)):"curve"===n.type?t.push((new P).move(r).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new P).move(r).line(i)),n.to&&(r=n.to)}return t},P.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},P.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},P.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],r=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var e=[],n="x"===r?new i(t,-1e5):new i(-1e4,t),o="x"===r?new i(t,1e5):new i(1e5,t),s=!0,h=!1,a=void 0;try{for(var p,u=this.divide()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;"line"===f.ops[1].type?C(l(f.ops[0].to,f.ops[1].to,n,o),e):"curve"===f.ops[1].type&&C(m(n,o,f.ops[0].to,f.ops[1].cp1,f.ops[1].cp2,f.ops[1].to),e)}}catch(t){h=!0,a=t}finally{try{!s&&u.return&&u.return()}finally{if(h)throw a}}return e},P.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var r=[],i=!0,e=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var h=o.value,a=!0,p=!1,u=void 0;try{for(var f,y=t.divide()[Symbol.iterator]();!(a=(f=y.next()).done);a=!0){var c=f.value;"line"===h.ops[1].type?"line"===c.ops[1].type?C(l(h.ops[0].to,h.ops[1].to,c.ops[0].to,c.ops[1].to),r):"curve"===c.ops[1].type&&C(m(h.ops[0].to,h.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),r):"curve"===h.ops[1].type&&("line"===c.ops[1].type?C(m(c.ops[0].to,c.ops[1].to,h.ops[0].to,h.ops[1].cp1,h.ops[1].cp2,h.ops[1].to),r):"curve"===c.ops[1].type&&C(w(h.ops[0].to,h.ops[1].cp1,h.ops[1].cp2,h.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),r))}}catch(t){p=!0,u=t}finally{try{!a&&y.return&&y.return()}finally{if(p)throw u}}}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}return r},P.prototype.split=function(t){var r=this.divide(),e=!1,n=!1;for(var o in r){var s=r[o];if("line"===s.ops[1].type)v(s.ops[0].to,s.ops[1].to,t)&&((e=r.slice(0,o)).push((new P).move(s.ops[0].to).line(t)),o++,(n=r.slice(o)).unshift((new P).move(t).line(s.ops[1].to)));else if("curve"===s.ops[1].type){var h=d(s.ops[0].to,s.ops[1].cp1,s.ops[1].cp2,s.ops[1].to,t);if(!1!==h){var a=new f({x:s.ops[0].to.x,y:s.ops[0].to.y},{x:s.ops[1].cp1.x,y:s.ops[1].cp1.y},{x:s.ops[1].cp2.x,y:s.ops[1].cp2.y},{x:s.ops[1].to.x,y:s.ops[1].to.y}).split(h);(e=r.slice(0,o)).push((new P).move(new i(a.left.points[0].x,a.left.points[0].y)).curve(new i(a.left.points[1].x,a.left.points[1].y),new i(a.left.points[2].x,a.left.points[2].y),new i(a.left.points[3].x,a.left.points[3].y))),o++,(n=r.slice(o)).unshift((new P).move(new i(a.right.points[0].x,a.right.points[0].y)).curve(new i(a.right.points[1].x,a.right.points[1].y),new i(a.right.points[2].x,a.right.points[2].y),new i(a.right.points[3].x,a.right.points[3].y)))}}}return e&&(e=I(e)),n&&(n=I(n)),[e,n]},P.prototype.trim=function(){var t=this.divide();for(var r in t)for(var e=parseInt(r)+2,n=parseInt(t.length)-1,o=e;o<n;o++){var s=t[r].intersects(t[o]);if(s.length>0){for(var h=s.pop(),a=t.slice(0,r),p=t.slice(parseInt(o)+1),u=new P,y=!0,c=[r,o],l=0;l<c.length;l++){var x=t[c[l]].ops;if("line"===x[1].type)u.line(h);else if("curve"===x[1].type){var v=new f({x:x[0].to.x,y:x[0].to.y},{x:x[1].cp1.x,y:x[1].cp1.y},{x:x[1].cp2.x,y:x[1].cp2.y},{x:x[1].to.x,y:x[1].to.y}),g=d(x[0].to,x[1].cp1,x[1].cp2,x[1].to,h),m=v.split(g),w=void 0;w=y?m.left:m.right,u.curve(new i(w.points[1].x,w.points[1].y),new i(w.points[2].x,w.points[2].y),new i(w.points[3].x,w.points[3].y))}y=!1}var b=void 0;return b=a.length>0?I(a).join(u):u,p.length>0&&(b=b.join(I(p))),b.trim()}}return this},P.prototype.translate=function(t,r){var i=this.clone(),e=!0,n=!1,o=void 0;try{for(var s,h=i.ops[Symbol.iterator]();!(e=(s=h.next()).done);e=!0){var a=s.value;"close"!==a.type&&(a.to=a.to.translate(t,r)),"curve"===a.type&&(a.cp1=a.cp1.translate(t,r),a.cp2=a.cp2.translate(t,r))}}catch(t){n=!0,o=t}finally{try{!e&&h.return&&h.return()}finally{if(n)throw o}}return i},E.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},E.prototype.clone=function(){var t=new E(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},A.prototype.macroClosure=function(t){var r=this;return function(t,i){var e=y(t);"function"==typeof r[e]?r[e](i):r.debug("warning","🚨 Macro not found","Macro "+e.substr(7)+" is not registered")}},A.prototype.debugClosure=function(){var t=this;return function(r,i,e,n,o){t.debug(r,i,e,n,o)}},A.prototype.debug=function(t){},A.prototype.getId=function(){return this.freeId+=1,""+this.freeId},A.prototype.unitsClosure=function(t){var r=this;return function(t){return g(t,r.context.settings.units)}},A.prototype.boundary=function(){if(this.topLeft)return this;var t=new i(1/0,1/0),r=new i(-1/0,-1/0);for(var e in this.paths){var n=this.paths[e].boundary();n.render&&(n.topLeft.x<t.x&&(t.x=n.topLeft.x),n.topLeft.y<t.y&&(t.y=n.topLeft.y),n.bottomRight.x>r.x&&(r.x=n.bottomRight.x),n.bottomRight.y>r.y&&(r.y=n.bottomRight.y))}for(var o in this.points){var s=this.points[o],h=s.attributes.get("data-circle");h&&(h=parseFloat(h),s.x-h<t.x&&(t.x=s.x-h),s.y-h<t.y&&(t.y=s.y-h),s.x+h>r.x&&(r.x=s.x+h),s.y+h>r.y&&(r.y=s.y+h))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),r.x===-1/0&&(r.x=0),r.y===-1/0&&(r.y=0);var a=this.context.settings.margin;return this.context.settings.paperless&&a<10&&(a=10),this.topLeft=new i(t.x-a,t.y-a),this.bottomRight=new i(r.x+a,r.y+a),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},A.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},A.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},A.prototype.copy=function(t){for(var r=["points","paths","snippets"],i=0;i<r.length;i++){var e=r[i];for(var n in t[e])void 0===this[e][n]&&(this[e][n]=t[e][n].clone())}return this},A.prototype.units=function(t){return g(t,this.context.settings.units)},A.prototype.shorthand=function(){var t=!!this.context.settings.complete,r=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:O,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:r,debug:this.debugClosure()}};var N="0.21.0";function F(t){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new r,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",N)}F.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var i=this.hooks[t];if(i.length>0){var e=!0,n=!1,o=void 0;try{for(var s,h=i[Symbol.iterator]();!(e=(s=h.next()).done);e=!0){var a=s.value;a.method(r,a.data)}}catch(t){n=!0,o=t}finally{try{!e&&h.return&&h.return()}finally{if(n)throw o}}}},F.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var r=!0,i=!1,e=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;t=s.method(t,s.data)}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}}return t},F.prototype.debug=function(){},F.prototype.render=function(t){for(var r in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var i=t.parts[r];i.render&&t.needs(r)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+r,i.attributes),this.svg+=this.renderPart(i),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},F.prototype.renderSvgTag=function(t){var r="<svg";return this.indent(),r+=this.nl()+this.attributes.render(),this.outdent(),r+=this.nl()+">"+this.nl()},F.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},F.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},F.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},F.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},F.prototype.renderPart=function(t){var r="";for(var i in t.paths){var e=t.paths[i];e.render&&(r+=this.renderPath(e))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(r+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(r+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];r+=this.renderSnippet(s,t)}return r},F.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},F.prototype.renderPathText=function(t){var r=t.attributes.get("data-text");if(!r)return"";this.text=this.insertText(r);var i=t.attributes.renderIfPrefixIs("data-text-"),e="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?e=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(e=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+e+"><tspan "+i+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},F.prototype.renderText=function(t){var r=t.attributes.getAsArray("data-text");if(!1!==r){var i="",e=!0,n=!1,o=void 0;try{for(var s,h=r[Symbol.iterator]();!(e=(s=h.next()).done);e=!0){var a=s.value;this.text=this.insertText(a),i+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!e&&h.return&&h.return()}finally{if(n)throw o}}this.text=this.insertText(i)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var f=this.text.split("\n");u+="<tspan>"+f.shift()+"</tspan>";var y=!0,c=!1,l=void 0;try{for(var x,v=f[Symbol.iterator]();!(y=(x=v.next()).done);y=!0){var d=x.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+d+"</tspan>"}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},F.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},F.prototype.renderSnippet=function(t,r){var i=t.anchor.x,e=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+i+", "+e+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*i+", "+-1*e+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+i+", "+e+")");var s=this.nl();return s+='<use x="'+i+'" y="'+e+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},F.prototype.openGroup=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.nl()+this.nl();return i+="\x3c!-- Start of group #"+t+" --\x3e",i+=this.nl(),i+='<g id="'+t+'"',r&&(i+=" "+r.render()),i+=">",this.indent(),this.openGroups.push(t),i},F.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},F.prototype.nl=function(){return"\n"+this.tab()},F.prototype.tab=function(){for(var t="",r=0;r<this.tabs;r++)t+="  ";return t},F.prototype.indent=function(){this.tabs+=1},F.prototype.outdent=function(){this.tabs-=1},F.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var H=function(){};H.prototype={fit:function(t){var r,i,e,n,o=t.length,s=o>0?t[0].width:0,h=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:h},r=0;r<o;r++)e=t[r],(i=this.findNode(this.root,e.width,e.height))?(n=this.splitNode(i,e.width,e.height),e.x=n.x,e.y=n.y):(n=this.growNode(e.width,e.height),e.x=n.x,e.y=n.y)},findNode:function(t,r,i){return t.used?this.findNode(t.right,r,i)||this.findNode(t.down,r,i):r<=t.width&&i<=t.height?t:null},splitNode:function(t,r,i){return t.used=!0,t.down={x:t.x,y:t.y+i,width:t.width,height:t.height-i},t.right={x:t.x+r,y:t.y,width:t.width-r,height:i},t},growNode:function(t,r){var i=t<=this.root.width,e=r<=this.root.height,n=e&&this.root.height>=this.root.width+t,o=i&&this.root.width>=this.root.height+r;return n?this.growRight(t,r):o?this.growDown(t,r):e?this.growRight(t,r):i?this.growDown(t,r):null},growRight:function(t,r){var i;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(i=this.findNode(this.root,t,r))?this.splitNode(i,t,r):null},growDown:function(t,r){var i;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+r,down:{x:0,y:this.root.height,width:this.root.width,height:r},right:this.root},(i=this.findNode(this.root,t,r))?this.splitNode(i,t,r):null}};var G=H;function q(){this.data=new Map}q.prototype.set=function(t,r){this.data.set(t,r)},q.prototype.setIfUnset=function(t,r){this.data.has(t)||this.data.set(t,r)},q.prototype.get=function(t){return this.data.get(t)};var D={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function B(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];for(var r in this.config=t,this.width=!1,this.height=!1,this.is="",this.store=new q,this.parts={},this.hooks=D,this.Part=A,this.Point=i,this.Path=P,this.Snippet=E,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},t.options){var e=t.options[r];if("object"===(void 0===e?"undefined":M(e)))if(void 0!==e.pct)this.settings.options[r]=e.pct/100;else if(void 0!==e.mm)this.settings.options[r]=e.mm;else if(void 0!==e.deg)this.settings.options[r]=e.deg;else if(void 0!==e.count)this.settings.options[r]=e.count;else{if(void 0===e.dflt)throw"Unknown option type";this.settings.options[r]=e.dflt}else this.settings.options[r]=e}this.context={parts:this.parts,config:this.config,settings:this.settings,store:this.store}}return B.prototype.createPart=function(){var t=new A;return t.context=this.context,t},B.prototype.mergeSettings=function(t){var r=!0,i=!1,e=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;"object"===M(t[s])?this.settings[s]=k({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){i=!0,e=t}finally{try{!r&&o.return&&o.return()}finally{if(i)throw e}}},B.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var i=this.hooks[t];if(i.length>0){var e=!0,n=!1,o=void 0;try{for(var s,h=i[Symbol.iterator]();!(e=(s=h.next()).done);e=!0){var a=s.value;a.method(r,a.data)}}catch(t){n=!0,o=t}finally{try{!e&&h.return&&h.return()}finally{if(n)throw o}}}},B.prototype.draft=function(){return this.is="draft",this.runHooks("preDraft"),this._draft(),this.runHooks("postDraft"),this},B.prototype._draft=function(){throw Error("You have to implement the _draft() method in your Pattern instance.")},B.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},B.prototype.sampleParts=function(){var t={};for(var r in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[r]=new A,t[r].render=this.parts[r].render;return t},B.prototype.sampleRun=function(t,r,i,e){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,h=0;for(var a in this.parts[o].points.anchor&&(void 0===r[o]?r[o]=this.parts[o].points.anchor:r[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(r[o]),h=this.parts[o].points.anchor.dy(r[o]))),this.parts[o].paths)t[o].paths[a+"_"+i]=this.parts[o].paths[a].clone().attr("style",_(i,e)),this.parts[o].points.anchor&&(t[o].paths[a+"_"+i]=t[o].paths[a+"_"+i].translate(s,h)),!1!==n&&t[o].paths[a+"_"+i].attributes.add("class",n)}},B.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var r,i=void 0,e=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===M(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(e=100),i=s.min/e,r=(s.max/e-i)/9;for(var h=1;h<11;h++)this.settings.options[t]=i,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+S(i)),this.sampleRun(o,n,h,10),i+=r;return this.parts=o,this.runHooks("postSample"),this},B.prototype.sampleListOption=function(t){var r=this.sampleParts(),i=this.config.options[t],e={},n=1,o=i.list.length,s=!0,h=!1,a=void 0;try{for(var p,u=i.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;this.settings.options[t]=f,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+S(f)),this.sampleRun(r,e,n,o),n++}}catch(t){h=!0,a=t}finally{try{!s&&u.return&&u.return()}finally{if(h)throw a}}return this.parts=r,this},B.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var r={},i=this.sampleParts(),e=this.settings.measurements[t];if(void 0===e)throw"Cannot sample a measurement that is undefined";var n=e/50;e*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=e,this.debug("info","🏃🏿‍♀️ Sample run","Sampling measurement "+t+" with value "+S(e)),this.sampleRun(i,r,o,10),e+=n;return this.parts=i,this.runHooks("postSample"),this},B.prototype.sampleModels=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var i={},e=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug("info","🏃🏿‍♀️ Sample run","Sampling model "+s);var h=s===r?"sample-focus":"";this.sampleRun(e,i,n,o,h)}return this.parts=e,this.runHooks("postSample"),this},B.prototype.debug=function(){for(var t=arguments.length,r=Array(t),i=0;i<t;i++)r[i]=arguments[i];this.runHooks("debug",r)},B.prototype.render=function(){return this.svg=new F(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},B.prototype.on=function(t,r,i){this.hooks[t].push({method:r,data:i})},B.prototype.with=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug("success","🔌 Plugin loaded",t.name+" v"+t.version),t.hooks&&this.loadPluginHooks(t,r),t.macros&&this.loadPluginMacros(t),this},B.prototype.loadPluginHooks=function(t,r){var i=!0,e=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var h=o.value;if("function"==typeof t.hooks[h])this.on(h,t.hooks[h],r);else if("object"===M(t.hooks[h])){var a=!0,p=!1,u=void 0;try{for(var f,y=t.hooks[h][Symbol.iterator]();!(a=(f=y.next()).done);a=!0){var c=f.value;this.on(h,c,r)}}catch(t){p=!0,u=t}finally{try{!a&&y.return&&y.return()}finally{if(p)throw u}}}}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}},B.prototype.loadPluginMacros=function(t){for(var r in t.macros)"function"==typeof t.macros[r]&&this.macro(r,t.macros[r])},B.prototype.macro=function(t,r){this.Part.prototype[y(t)]=r},B.prototype.pack=function(){var t=[];for(var r in this.parts){var i=this.parts[r];i.attributes.set("transform",""),i.render&&this.needs(r)&&(i.stack(),t.push({id:r,width:i.bottomRight.x-i.topLeft.x,height:i.bottomRight.y-i.topLeft.y}))}var e=function(t,r){r=r||{};var i=new G,e=r.inPlace||!1,n=t.map(function(t){return e?t:{width:t.width,height:t.height,item:t}});n=n.sort(function(t,r){return r.width*r.height-t.width*t.height}),i.fit(n);var o={width:n.reduce(function(t,r){return Math.max(t,r.x+r.width)},0),height:n.reduce(function(t,r){return Math.max(t,r.y+r.height)},0)};return e||(o.items=n),o}(t,{inPlace:!0}),n=!0,o=!1,s=void 0;try{for(var h,a=t[Symbol.iterator]();!(n=(h=a.next()).done);n=!0){var p=h.value,u=this.parts[p.id];0===p.x&&0===p.y||u.attr("transform","translate ("+p.x+", "+p.y+")")}}catch(t){o=!0,s=t}finally{try{!n&&a.return&&a.return()}finally{if(o)throw s}}return this.width=e.width,this.height=e.height,this},B.prototype.needs=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if("string"!=typeof t){var i=!0,e=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(i=(o=s.next()).done);i=!0){var h=o.value;if(this.needs(h,r))return!0}}catch(t){e=!0,n=t}finally{try{!i&&s.return&&s.return()}finally{if(e)throw n}}return!1}return void 0===this.settings.only?!r:this.settings.only===t||"object"===M(this.settings.only)&&-1!==this.settings.only.indexOf(t)},{version:N,Pattern:B,Point:i,Path:P,Snippet:E,utils:O,patterns:{},plugins:{}}}(crypto);
//# sourceMappingURL=browser.js.map
