/**
 * freesewing | v0.21.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
"use strict";function _interopDefault(t){return t&&"object"==typeof t&&"default"in t?t.default:t}var Bezier=_interopDefault(require("bezier-js"));require("crypto");var pack=_interopDefault(require("bin-pack"));function Attributes(){this.list={}}function Point(t,e){this.x=round(t),this.y=round(e),this.attributes=new Attributes}function macroName(t){return"_macro_"+t}function beamsIntersect(t,e,r,i){var o=t.slope(e),n=r.slope(i);if(o===n)return!1;if(t.x===e.x)return new Point(t.x,n*t.x+(r.y-n*r.x));if(r.x===i.x)return new Point(r.x,o*r.x+(t.y-o*t.x));t.x>e.x&&(t=e.copy()),r.x>i.x&&(r=i.copy());var s=t.y-o*t.x,a=(r.y-n*r.x-s)/(o-n);return new Point(a,o*a+s)}function linesIntersect(t,e,r,i){var o=beamsIntersect(t,e,r,i);if(!o)return!1;var n=t.dist(e),s=r.dist(i),a=t.dist(o)+o.dist(e),p=r.dist(o)+o.dist(i);return Math.round(n)==Math.round(a)&&Math.round(s)==Math.round(p)&&o}function pointOnBeam(t,e,r){var i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(r))return!0;if(e.sitsOn(r))return!0;var o=r.dx(t)*e.dy(t)-r.dy(t)*e.dx(t);return 0===Math.abs(Math.round(o*i)/i)}function pointOnLine(t,e,r){if(!pointOnBeam(t,e,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var i=t.dist(e),o=t.dist(r)+r.dist(e);return Math.round(i)==Math.round(o)}function pointOnCurve(t,e,r,i,o){if(t.sitsOn(o))return!0;if(i.sitsOn(o))return!0;var n=new Bezier({x:t.x,y:t.y},{x:e.x,y:e.y},{x:r.x,y:r.y},{x:i.x,y:i.y}).intersects({p1:{x:o.x-1,y:o.y},p2:{x:o.x+1,y:o.y}});return n.length>0&&n.shift()}function beamIntersectsX(t,e,r){return t.x!==e.x&&beamsIntersect(t,e,new Point(r,-10),new Point(r,10))}function beamIntersectsY(t,e,r){return t.y!==e.y&&beamsIntersect(t,e,new Point(-10,r),new Point(10,r))}function units(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?round(t/25.4)+'"':round(t/10)+"cm"}function lineIntersectsCurve(t,e,r,i,o,n){var s=[],a=new Bezier({x:r.x,y:r.y},{x:i.x,y:i.y},{x:o.x,y:o.y},{x:n.x,y:n.y}),p={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}},h=!0,u=!1,y=void 0;try{for(var f,l=a.intersects(p)[Symbol.iterator]();!(h=(f=l.next()).done);h=!0){var c=f.value,v=a.get(c);s.push(new Point(v.x,v.y))}}catch(t){u=!0,y=t}finally{try{!h&&l.return&&l.return()}finally{if(u)throw y}}return 0!==s.length&&(1===s.length?s[0]:s)}function curvesIntersect(t,e,r,i,o,n,s,a){var p=[],h=new Bezier({x:t.x,y:t.y},{x:e.x,y:e.y},{x:r.x,y:r.y},{x:i.x,y:i.y}),u=new Bezier({x:o.x,y:o.y},{x:n.x,y:n.y},{x:s.x,y:s.y},{x:a.x,y:a.y}),y=!0,f=!1,l=void 0;try{for(var c,v=h.intersects(u,.005)[Symbol.iterator]();!(y=(c=v.next()).done);y=!0){var d=c.value,x=h.get(d.substr(0,d.indexOf("/")));p.push(new Point(x.x,x.y))}}catch(t){f=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(f)throw l}}if(0===p.length)return!1;if(1===p.length)return p.shift();var g=[],m=!0,b=!1,P=void 0;try{for(var w,S=p[Symbol.iterator]();!(m=(w=S.next()).done);m=!0){var O=w.value,I=!1,L=!0,R=!1,k=void 0;try{for(var A,M=g[Symbol.iterator]();!(L=(A=M.next()).done);L=!0){var C=A.value;O.sitsRoughlyOn(C)&&(I=!0)}}catch(t){R=!0,k=t}finally{try{!L&&M.return&&M.return()}finally{if(R)throw k}}I||g.push(O)}}catch(t){b=!0,P=t}finally{try{!m&&S.return&&S.return()}finally{if(b)throw P}}return g}function circlesIntersect(t,e,r,i){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",n=t.dx(r),s=t.dy(r),a=t.dist(r);if(a>parseFloat(e)+parseFloat(i))return!1;if(a<parseFloat(i)-parseFloat(e))return!1;if(0===a&&e===i)return!1;var p=(Math.pow(e,2)-Math.pow(i,2)+Math.pow(a,2))/(2*a),h=Math.sqrt(Math.pow(e,2)-Math.pow(p,2)),u=t.x+p*n/a,y=t.y+p*s/a,f=new Point(u+h*s/a,y-h*n/a),l=new Point(u-h*s/a,y+h*n/a);return"x"===o&&f.x<=l.x||"y"===o&&f.y<=l.y?[f,l]:[l,f]}function beamIntersectsCircle(t,e,r,i){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",n=i.x-r.x,s=i.y-r.y,a=Math.pow(n,2)+Math.pow(s,2),p=2*(n*(r.x-t.x)+s*(r.y-t.y)),h=Math.pow(r.x-t.x,2)+Math.pow(r.y-t.y,2)-Math.pow(e,2),u=Math.pow(p,2)-4*a*h;if(a<=1e-7||u<0)return!1;if(0===u){var y=-1*p/(2*a);return[new Point(r.x+y*n,r.y+y*s)]}var f=(-1*p+Math.sqrt(u))/(2*a),l=new Point(r.x+f*n,r.y+f*s);f=(-1*p-Math.sqrt(u))/(2*a);var c=new Point(r.x+f*n,r.y+f*s);return"x"===o&&l.x<=c.x||"y"===o&&l.y<=c.y?[l,c]:[c,l]}function lineIntersectsCircle(t,e,r,i){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",n=beamIntersectsCircle(t,e,r,i,o);if(!1===n)return!1;if(1===n.length)return!!pointOnLine(r,i,n[0])&&n;var s=n[0],a=n[1];return!(!pointOnLine(r,i,s,5)&&!pointOnLine(r,i,a,5))&&(pointOnLine(r,i,s,5)&&pointOnLine(r,i,a,5)?"x"===o&&s.x<=a.x||"y"===o&&s.y<=a.y?[s,a]:[a,s]:pointOnLine(r,i,s,5)?[s]:pointOnLine(r,i,a,5)?[a]:void 0)}function curveEdge(t,e){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,i=1/0,o=1/0,n=void 0;"bottom"===e&&(o=-1/0),"right"===e&&(i=-1/0);for(var s=0;s<r;s++)n=t.get(s/r),("top"===e&&n.y<o||"bottom"===e&&n.y>o||"right"===e&&n.x>i||"left"===e&&n.x<i)&&(i=n.x,o=n.y);return new Point(i,o)}function stretchToScale(t){return 1/(1+parseFloat(t))}function round(t){return Math.round(100*t)/100}function sampleStyle(t,e){return"stroke: hsl("+330/e*(t-1)+", 100%, 35%);"}Attributes.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},Attributes.prototype.set=function(t,e){return this.list[t]=[e],this},Attributes.prototype.remove=function(t){return delete this.list[t],this},Attributes.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},Attributes.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},Attributes.prototype.render=function(){var t="";for(var e in this.list)t+=" "+e+'="'+this.list[e].join(" ")+'"';return t},Attributes.prototype.renderAsCss=function(){var t="";for(var e in this.list)t+=" "+e+":"+this.list[e].join(" ")+";";return t},Attributes.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",e="",r=t.length;for(var i in this.list)i.substr(0,r)===t&&(e+=" "+i.substr(r)+'="'+this.list[i].join(" ")+'"');return e},Attributes.prototype.clone=function(){var t=new Attributes;return t.list=JSON.parse(JSON.stringify(this.list)),t},Point.prototype.rad2deg=function(t){return 57.29577951308232*t},Point.prototype.deg2rad=function(t){return t/57.29577951308232},Point.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Point.prototype.dist=function(t){var e=this.x-t.x,r=this.y-t.y;return round(Math.sqrt(Math.pow(e,2)+Math.pow(r,2)))},Point.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},Point.prototype.dx=function(t){return t.x-this.x},Point.prototype.dy=function(t){return t.y-this.y},Point.prototype.angle=function(t){for(var e=Math.atan2(-1*this.dy(t),this.dx(t));e<0;)e+=2*Math.PI;return this.rad2deg(e)},Point.prototype.rotate=function(t,e){var r=this.dist(e),i=this.angle(e);return new Point(e.x+r*Math.cos(this.deg2rad(i+t))*-1,e.y+r*Math.sin(this.deg2rad(i+t)))},Point.prototype.copy=function(){return new Point(this.x,this.y)},Point.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(!1===t?-1*this.x:t.x+this.dx(t),this.y)},Point.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(this.x,!1===t?-1*this.y:t.y+this.dy(t))},Point.prototype.shift=function(t,e){var r=this.copy();return r.x+=e,r.rotate(t,this)},Point.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},Point.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},Point.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},Point.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},Point.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},Point.prototype.clone=function(){var t=new Point(this.x,this.y);return t.attributes=this.attributes.clone(),t},Point.prototype.translate=function(t,e){var r=this.copy();return r.x+=t,r.y+=e,r};var utils=Object.freeze({macroName:macroName,beamsIntersect:beamsIntersect,linesIntersect:linesIntersect,pointOnBeam:pointOnBeam,pointOnLine:pointOnLine,pointOnCurve:pointOnCurve,beamIntersectsX:beamIntersectsX,beamIntersectsY:beamIntersectsY,units:units,lineIntersectsCurve:lineIntersectsCurve,curvesIntersect:curvesIntersect,circlesIntersect:circlesIntersect,beamIntersectsCircle:beamIntersectsCircle,lineIntersectsCircle:lineIntersectsCircle,curveEdge:curveEdge,stretchToScale:stretchToScale,round:round,sampleStyle:sampleStyle}),_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},_extends=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&(t[i]=r[i])}return t};function Path(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new Attributes,this.ops=[]}function pathOffset(t,e){var r=[],i=void 0,o=!1;for(var n in t.ops){var s=t.ops[n];if("line"===s.type){var a=offsetLine(i,s.to,e);a&&r.push(a)}else if("curve"===s.type){var p=void 0,h=void 0;p=i.sitsRoughlyOn(s.cp1)?(new Path).move(i).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,h=s.cp2.sitsRoughlyOn(s.to)?(new Path).move(s.to).curve(s.cp2,s.cp1,i).shiftAlong(2):s.cp2;var u=new Bezier({x:i.x,y:i.y},{x:p.x,y:p.y},{x:h.x,y:h.y},{x:s.to.x,y:s.to.y}),y=!0,f=!1,l=void 0;try{for(var c,v=u.offset(e)[Symbol.iterator]();!(y=(c=v.next()).done);y=!0){var d=c.value;r.push(asPath(d))}}catch(t){f=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(f)throw l}}}else"close"===s.type&&(o=!0);s.to&&(i=s.to)}return joinPaths(r,o)}function offsetLine(t,e,r){if(t.x===e.x&&t.y===e.y)return!1;var i=t.angle(e)-90;return(new Path).move(t.shift(i,r)).line(e.shift(i,r))}function asPath(t){return(new Path).move(new Point(t.points[0].x,t.points[0].y)).curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}function joinPaths(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=(new Path).move(t[0].ops[0].to),i=void 0,o=!0,n=!1,s=void 0;try{for(var a,p=t[Symbol.iterator]();!(o=(a=p.next()).done);o=!0){var h=a.value,u=!0,y=!1,f=void 0;try{for(var l,c=h.ops[Symbol.iterator]();!(u=(l=c.next()).done);u=!0){var v=l.value;if("curve"===v.type)r.curve(v.cp1,v.cp2,v.to);else{if("close"===v.type)throw"Cannot join a closed paths with another";i&&!v.to.sitsRoughlyOn(i)&&r.line(v.to)}v.to&&(i=v.to)}}catch(t){y=!0,f=t}finally{try{!u&&c.return&&c.return()}finally{if(y)throw f}}}}catch(t){n=!0,s=t}finally{try{!o&&p.return&&p.return()}finally{if(n)throw s}}return e&&r.close(),r}function shiftAlongBezier(t,e){for(var r=void 0,i=void 0,o=void 0,n=void 0,s=0,a=0;a<=100;a++){if(o=a/100,i=new Point((i=e.get(o)).x,i.y),a>0){if(s+(n=i.dist(r))>t)return i;s+=n}r=i}}function lineBoundingBox(t){var e=t.from,r=t.to;return e.x===r.x?e.y<r.y?{topLeft:e,bottomRight:r}:{topLeft:r,bottomRight:e}:e.y===r.y?e.x<r.x?{topLeft:e,bottomRight:r}:{topLeft:r,bottomRight:e}:e.x<r.x?e.y<r.y?{topLeft:e,bottomRight:r}:{topLeft:new Point(e.x,r.y),bottomRight:new Point(r.x,e.y)}:e.x>r.x?e.y<r.y?{topLeft:new Point(r.x,e.y),bottomRight:new Point(e.x,r.y)}:{topLeft:new Point(r.x,r.y),bottomRight:new Point(e.x,e.y)}:void 0}function curveBoundingBox(t){var e=t.bbox();return{topLeft:new Point(e.x.min,e.y.min),bottomRight:new Point(e.x.max,e.y.max)}}function bbbbox(t){var e=1/0,r=-1/0,i=1/0,o=-1/0,n=!0,s=!1,a=void 0;try{for(var p,h=t[Symbol.iterator]();!(n=(p=h.next()).done);n=!0){var u=p.value;u.topLeft.x<e&&(e=u.topLeft.x),u.topLeft.y<i&&(i=u.topLeft.y),u.bottomRight.x>r&&(r=u.bottomRight.x),u.bottomRight.y>o&&(o=u.bottomRight.y)}}catch(t){s=!0,a=t}finally{try{!n&&h.return&&h.return()}finally{if(s)throw a}}return{topLeft:new Point(e,i),bottomRight:new Point(r,o)}}function edgeCurveAsBezier(t){return new Bezier({x:t.from.x,y:t.from.y},{x:t.cp1.x,y:t.cp1.y},{x:t.cp2.x,y:t.cp2.y},{x:t.to.x,y:t.to.y})}function addIntersectionsToArray(t,e){if(t&&"object"===(void 0===t?"undefined":_typeof(t)))if("number"==typeof t.x)e.push(t);else{var r=!0,i=!1,o=void 0;try{for(var n,s=t[Symbol.iterator]();!(r=(n=s.next()).done);r=!0){var a=n.value;e.push(a)}}catch(t){i=!0,o=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw o}}}}function Snippet(t,e){return this.def=t,this.anchor=e,this.attributes=new Attributes,this}function Part(){return this.attributes=new Attributes,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=utils,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this}Path.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},Path.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},Path.prototype.curve=function(t,e,r){return this.ops.push({type:"curve",cp1:t,cp2:e,to:r}),this},Path.prototype.close=function(){return this.ops.push({type:"close"}),this},Path.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Path.prototype.asPathstring=function(){var t="",e=!0,r=!1,i=void 0;try{for(var o,n=this.ops[Symbol.iterator]();!(e=(o=n.next()).done);e=!0){var s=o.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){r=!0,i=t}finally{try{!e&&n.return&&n.return()}finally{if(r)throw i}}return t},Path.prototype.offset=function(t){return pathOffset(this,t)},Path.prototype.length=function(){var t=void 0,e=void 0,r=0;for(var i in this.ops){var o=this.ops[i];"move"===o.type?e=o.to:"line"===o.type?r+=t.dist(o.to):"curve"===o.type?r+=new Bezier({x:t.x,y:t.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}).length():"close"===o.type&&(r+=t.dist(e)),o.to&&(t=o.to)}return round(r)},Path.prototype.start=function(){return this.ops[0].to},Path.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},Path.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,e=new Point(1/0,1/0),r=new Point(-1/0,-1/0),i=[];for(var o in this.ops){var n=this.ops[o];if("move"===n.type||"line"===n.type)n.to.x<e.x&&(e.x=n.to.x,i.leftOp=o),n.to.y<e.y&&(e.y=n.to.y,i.topOp=o),n.to.x>r.x&&(r.x=n.to.x,i.rightOp=o),n.to.y>r.y&&(r.y=n.to.y,i.bottomOp=o);else if("curve"===n.type){var s=new Bezier({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).bbox();s.x.min<e.x&&(e.x=s.x.min,i.leftOp=o),s.y.min<e.y&&(e.y=s.y.min,i.topOp=o),s.x.max>r.x&&(r.x=s.x.max,i.rightOp=o),s.y.max>r.y&&(r.y=s.y.max,i.bottomOp=o)}n.to&&(t=n.to)}this.topLeft=e,this.bottomRight=r;for(var a=["top","left","bottom","right"],p=0;p<a.length;p++){var h=a[p]+"Op";this[h]=this.ops[i[h]],this[h].from="move"===this[h].type?this[h].to:this.ops[i[h]-1].to}return this},Path.prototype.clone=function(){var t=new Path;for(var e in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var r=this.ops[e];t.ops[e]={type:r.type},"move"===r.type||"line"===r.type?t.ops[e].to=r.to.clone():"curve"===r.type&&(t.ops[e].to=r.to.clone(),t.ops[e].cp1=r.cp1.clone(),t.ops[e].cp2=r.cp2.clone())}return t},Path.prototype.join=function(t){return joinPaths([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},Path.prototype.shiftAlong=function(t){var e=0,r=void 0;for(var i in this.ops){var o=this.ops[i];if("line"===o.type){var n=o.to.dist(r);if(e+n>t)return r.shiftTowards(o.to,t-e);e+=n}else if("curve"===o.type){var s=new Bezier({x:r.x,y:r.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}),a=s.length();if(e+a>t)return shiftAlongBezier(t-e,s);e+=a}r=o.to}throw"Ran out of path to shift along"},Path.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},Path.prototype.bbox=function(){var t=[],e=void 0;for(var r in this.ops){var i=this.ops[r];"line"===i.type?t.push(lineBoundingBox({from:e,to:i.to})):"curve"===i.type&&t.push(curveBoundingBox(new Bezier({x:e.x,y:e.y},{x:i.cp1.x,y:i.cp1.y},{x:i.cp2.x,y:i.cp2.y},{x:i.to.x,y:i.to.y}))),i.to&&(e=i.to)}return bbbbox(t)},Path.prototype.reverse=function(){var t=[],e=void 0,r=!1;for(var i in this.ops){var o=this.ops[i];"line"===o.type?o.to.sitsOn(e)||t.push((new Path).move(o.to).line(e)):"curve"===o.type?t.push((new Path).move(o.to).curve(o.cp2,o.cp1,e)):"close"===o.type&&(r=!0),o.to&&(e=o.to)}var n=(new Path).move(e),s=!0,a=!1,p=void 0;try{for(var h,u=t.reverse()[Symbol.iterator]();!(s=(h=u.next()).done);s=!0){var y=h.value;n.ops.push(y.ops[1])}}catch(t){a=!0,p=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw p}}return r&&n.close(),n},Path.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new Point(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new Point(this.topLeft.x,this.bottomRight.y);var e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return curveEdge(edgeCurveAsBezier(this[e]),t)}},Path.prototype.divide=function(){var t=[],e=void 0,r=void 0;for(var i in this.ops){var o=this.ops[i];"move"===o.type?r=o.to:"line"===o.type?o.to.sitsRoughlyOn(e)||t.push((new Path).move(e).line(o.to)):"curve"===o.type?t.push((new Path).move(e).curve(o.cp1,o.cp2,o.to)):"close"===o.type&&t.push((new Path).move(e).line(r)),o.to&&(e=o.to)}return t},Path.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},Path.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},Path.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],e=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var r=[],i="x"===e?new Point(t,-1e5):new Point(-1e4,t),o="x"===e?new Point(t,1e5):new Point(1e5,t),n=!0,s=!1,a=void 0;try{for(var p,h=this.divide()[Symbol.iterator]();!(n=(p=h.next()).done);n=!0){var u=p.value;"line"===u.ops[1].type?addIntersectionsToArray(linesIntersect(u.ops[0].to,u.ops[1].to,i,o),r):"curve"===u.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(i,o,u.ops[0].to,u.ops[1].cp1,u.ops[1].cp2,u.ops[1].to),r)}}catch(t){s=!0,a=t}finally{try{!n&&h.return&&h.return()}finally{if(s)throw a}}return r},Path.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var e=[],r=!0,i=!1,o=void 0;try{for(var n,s=this.divide()[Symbol.iterator]();!(r=(n=s.next()).done);r=!0){var a=n.value,p=!0,h=!1,u=void 0;try{for(var y,f=t.divide()[Symbol.iterator]();!(p=(y=f.next()).done);p=!0){var l=y.value;"line"===a.ops[1].type?"line"===l.ops[1].type?addIntersectionsToArray(linesIntersect(a.ops[0].to,a.ops[1].to,l.ops[0].to,l.ops[1].to),e):"curve"===l.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(a.ops[0].to,a.ops[1].to,l.ops[0].to,l.ops[1].cp1,l.ops[1].cp2,l.ops[1].to),e):"curve"===a.ops[1].type&&("line"===l.ops[1].type?addIntersectionsToArray(lineIntersectsCurve(l.ops[0].to,l.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),e):"curve"===l.ops[1].type&&addIntersectionsToArray(curvesIntersect(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,l.ops[0].to,l.ops[1].cp1,l.ops[1].cp2,l.ops[1].to),e))}}catch(t){h=!0,u=t}finally{try{!p&&f.return&&f.return()}finally{if(h)throw u}}}}catch(t){i=!0,o=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw o}}return e},Path.prototype.split=function(t){var e=this.divide(),r=!1,i=!1;for(var o in e){var n=e[o];if("line"===n.ops[1].type)pointOnLine(n.ops[0].to,n.ops[1].to,t)&&((r=e.slice(0,o)).push((new Path).move(n.ops[0].to).line(t)),o++,(i=e.slice(o)).unshift((new Path).move(t).line(n.ops[1].to)));else if("curve"===n.ops[1].type){var s=pointOnCurve(n.ops[0].to,n.ops[1].cp1,n.ops[1].cp2,n.ops[1].to,t);if(!1!==s){var a=new Bezier({x:n.ops[0].to.x,y:n.ops[0].to.y},{x:n.ops[1].cp1.x,y:n.ops[1].cp1.y},{x:n.ops[1].cp2.x,y:n.ops[1].cp2.y},{x:n.ops[1].to.x,y:n.ops[1].to.y}).split(s);(r=e.slice(0,o)).push((new Path).move(new Point(a.left.points[0].x,a.left.points[0].y)).curve(new Point(a.left.points[1].x,a.left.points[1].y),new Point(a.left.points[2].x,a.left.points[2].y),new Point(a.left.points[3].x,a.left.points[3].y))),o++,(i=e.slice(o)).unshift((new Path).move(new Point(a.right.points[0].x,a.right.points[0].y)).curve(new Point(a.right.points[1].x,a.right.points[1].y),new Point(a.right.points[2].x,a.right.points[2].y),new Point(a.right.points[3].x,a.right.points[3].y)))}}}return r&&(r=joinPaths(r)),i&&(i=joinPaths(i)),[r,i]},Path.prototype.trim=function(){var t=this.divide();for(var e in t)for(var r=parseInt(e)+2,i=parseInt(t.length)-1,o=r;o<i;o++){var n=t[e].intersects(t[o]);if(n.length>0){for(var s=n.pop(),a=t.slice(0,e),p=t.slice(parseInt(o)+1),h=new Path,u=!0,y=[e,o],f=0;f<y.length;f++){var l=t[y[f]].ops;if("line"===l[1].type)h.line(s);else if("curve"===l[1].type){var c=new Bezier({x:l[0].to.x,y:l[0].to.y},{x:l[1].cp1.x,y:l[1].cp1.y},{x:l[1].cp2.x,y:l[1].cp2.y},{x:l[1].to.x,y:l[1].to.y}),v=pointOnCurve(l[0].to,l[1].cp1,l[1].cp2,l[1].to,s),d=c.split(v),x=void 0;x=u?d.left:d.right,h.curve(new Point(x.points[1].x,x.points[1].y),new Point(x.points[2].x,x.points[2].y),new Point(x.points[3].x,x.points[3].y))}u=!1}var g=void 0;return g=a.length>0?joinPaths(a).join(h):h,p.length>0&&(g=g.join(joinPaths(p))),g.trim()}}return this},Path.prototype.translate=function(t,e){var r=this.clone(),i=!0,o=!1,n=void 0;try{for(var s,a=r.ops[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var p=s.value;"close"!==p.type&&(p.to=p.to.translate(t,e)),"curve"===p.type&&(p.cp1=p.cp1.translate(t,e),p.cp2=p.cp2.translate(t,e))}}catch(t){o=!0,n=t}finally{try{!i&&a.return&&a.return()}finally{if(o)throw n}}return r},Snippet.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Snippet.prototype.clone=function(){var t=new Snippet(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},Part.prototype.macroClosure=function(t){var e=this;return function(t,r){var i=macroName(t);"function"==typeof e[i]?e[i](r):e.debug("warning","🚨 Macro not found","Macro "+i.substr(7)+" is not registered")}},Part.prototype.debugClosure=function(){var t=this;return function(e,r,i,o,n){t.debug(e,r,i,o,n)}},Part.prototype.debug=function(t){},Part.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Part.prototype.unitsClosure=function(t){var e=this;return function(t){return units(t,e.context.settings.units)}},Part.prototype.boundary=function(){if(this.topLeft)return this;var t=new Point(1/0,1/0),e=new Point(-1/0,-1/0);for(var r in this.paths){var i=this.paths[r].boundary();i.render&&(i.topLeft.x<t.x&&(t.x=i.topLeft.x),i.topLeft.y<t.y&&(t.y=i.topLeft.y),i.bottomRight.x>e.x&&(e.x=i.bottomRight.x),i.bottomRight.y>e.y&&(e.y=i.bottomRight.y))}for(var o in this.points){var n=this.points[o],s=n.attributes.get("data-circle");s&&(s=parseFloat(s),n.x-s<t.x&&(t.x=n.x-s),n.y-s<t.y&&(t.y=n.y-s),n.x+s>e.x&&(e.x=n.x+s),n.y+s>e.y&&(e.y=n.y+s))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);var a=this.context.settings.margin;return this.context.settings.paperless&&a<10&&(a=10),this.topLeft=new Point(t.x-a,t.y-a),this.bottomRight=new Point(e.x+a,e.y+a),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},Part.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},Part.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Part.prototype.copy=function(t){for(var e=["points","paths","snippets"],r=0;r<e.length;r++){var i=e[r];for(var o in t[i])void 0===this[i][o]&&(this[i][o]=t[i][o].clone())}return this},Part.prototype.units=function(t){return units(t,this.context.settings.units)},Part.prototype.shorthand=function(){var t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:utils,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var version="0.21.0";function Svg(t){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new Attributes,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",version)}function Store(){this.data=new Map}Svg.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var r=this.hooks[t];if(r.length>0){var i=!0,o=!1,n=void 0;try{for(var s,a=r[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var p=s.value;p.method(e,p.data)}}catch(t){o=!0,n=t}finally{try{!i&&a.return&&a.return()}finally{if(o)throw n}}}},Svg.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var e=!0,r=!1,i=void 0;try{for(var o,n=this.hooks.insertText[Symbol.iterator]();!(e=(o=n.next()).done);e=!0){var s=o.value;t=s.method(t,s.data)}}catch(t){r=!0,i=t}finally{try{!e&&n.return&&n.return()}finally{if(r)throw i}}}return t},Svg.prototype.debug=function(){},Svg.prototype.render=function(t){for(var e in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var r=t.parts[e];r.render&&t.needs(e)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+e,r.attributes),this.svg+=this.renderPart(r),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},Svg.prototype.renderSvgTag=function(t){var e="<svg";return this.indent(),e+=this.nl()+this.attributes.render(),this.outdent(),e+=this.nl()+">"+this.nl()},Svg.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},Svg.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},Svg.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},Svg.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},Svg.prototype.renderPart=function(t){var e="";for(var r in t.paths){var i=t.paths[r];i.render&&(e+=this.renderPath(i))}for(var o in t.points)t.points[o].attributes.get("data-text")&&(e+=this.renderText(t.points[o])),t.points[o].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[o]));for(var n in t.snippets){var s=t.snippets[n];e+=this.renderSnippet(s,t)}return e},Svg.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},Svg.prototype.renderPathText=function(t){var e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);var r=t.attributes.renderIfPrefixIs("data-text-"),i="",o=t.attributes.get("data-text-class");o&&o.indexOf("center")>-1?i=' startOffset="50%" ':o&&o.indexOf("right")>-1&&(i=' startOffset="100%" ');var n=this.nl()+"<text>";return this.indent(),n+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+i+"><tspan "+r+">"+this.text+"</tspan></textPath>",this.outdent(),n+=this.nl()+"</text>"},Svg.prototype.renderText=function(t){var e=t.attributes.getAsArray("data-text");if(!1!==e){var r="",i=!0,o=!1,n=void 0;try{for(var s,a=e[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var p=s.value;this.text=this.insertText(p),r+=this.text+" "}}catch(t){o=!0,n=t}finally{try{!i&&a.return&&a.return()}finally{if(o)throw n}}this.text=this.insertText(r)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var h=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var y=this.text.split("\n");u+="<tspan>"+y.shift()+"</tspan>";var f=!0,l=!1,c=void 0;try{for(var v,d=y[Symbol.iterator]();!(f=(v=d.next()).done);f=!0){var x=v.value;u+='<tspan x="'+t.x+'" dy="'+h+'">'+x+"</tspan>"}}catch(t){l=!0,c=t}finally{try{!f&&d.return&&d.return()}finally{if(l)throw c}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},Svg.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},Svg.prototype.renderSnippet=function(t,e){var r=t.anchor.x,i=t.anchor.y,o=t.attributes.get("data-scale");o&&(t.attributes.add("transform","translate("+r+", "+i+")"),t.attributes.add("transform","scale("+o+")"),t.attributes.add("transform","translate("+-1*r+", "+-1*i+")"));var n=t.attributes.get("data-rotate");n&&t.attributes.add("transform","rotate("+n+", "+r+", "+i+")");var s=this.nl();return s+='<use x="'+r+'" y="'+i+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},Svg.prototype.openGroup=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=this.nl()+this.nl();return r+="\x3c!-- Start of group #"+t+" --\x3e",r+=this.nl(),r+='<g id="'+t+'"',e&&(r+=" "+e.render()),r+=">",this.indent(),this.openGroups.push(t),r},Svg.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},Svg.prototype.nl=function(){return"\n"+this.tab()},Svg.prototype.tab=function(){for(var t="",e=0;e<this.tabs;e++)t+="  ";return t},Svg.prototype.indent=function(){this.tabs+=1},Svg.prototype.outdent=function(){this.tabs-=1},Svg.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Store.prototype.set=function(t,e){this.data.set(t,e)},Store.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},Store.prototype.get=function(t){return this.data.get(t)};var hooks={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function Pattern(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];for(var e in this.config=t,this.width=!1,this.height=!1,this.is="",this.store=new Store,this.parts={},this.hooks=hooks,this.Part=Part,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},t.options){var r=t.options[e];if("object"===(void 0===r?"undefined":_typeof(r)))if(void 0!==r.pct)this.settings.options[e]=r.pct/100;else if(void 0!==r.mm)this.settings.options[e]=r.mm;else if(void 0!==r.deg)this.settings.options[e]=r.deg;else if(void 0!==r.count)this.settings.options[e]=r.count;else{if(void 0===r.dflt)throw"Unknown option type";this.settings.options[e]=r.dflt}else this.settings.options[e]=r}this.context={parts:this.parts,config:this.config,settings:this.settings,store:this.store}}Pattern.prototype.createPart=function(){var t=new Part;return t.context=this.context,t},Pattern.prototype.mergeSettings=function(t){var e=!0,r=!1,i=void 0;try{for(var o,n=Object.keys(t)[Symbol.iterator]();!(e=(o=n.next()).done);e=!0){var s=o.value;"object"===_typeof(t[s])?this.settings[s]=_extends({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){r=!0,i=t}finally{try{!e&&n.return&&n.return()}finally{if(r)throw i}}},Pattern.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var r=this.hooks[t];if(r.length>0){var i=!0,o=!1,n=void 0;try{for(var s,a=r[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var p=s.value;p.method(e,p.data)}}catch(t){o=!0,n=t}finally{try{!i&&a.return&&a.return()}finally{if(o)throw n}}}},Pattern.prototype.draft=function(){return this.is="draft",this.runHooks("preDraft"),this._draft(),this.runHooks("postDraft"),this},Pattern.prototype._draft=function(){throw Error("You have to implement the _draft() method in your Pattern instance.")},Pattern.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},Pattern.prototype.sampleParts=function(){var t={};for(var e in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[e]=new Part,t[e].render=this.parts[e].render;return t},Pattern.prototype.sampleRun=function(t,e,r,i){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var n in this.draft(),this.parts){var s=0,a=0;for(var p in this.parts[n].points.anchor&&(void 0===e[n]?e[n]=this.parts[n].points.anchor:e[n].sitsOn(this.parts[n].points.anchor)||(s=this.parts[n].points.anchor.dx(e[n]),a=this.parts[n].points.anchor.dy(e[n]))),this.parts[n].paths)t[n].paths[p+"_"+r]=this.parts[n].paths[p].clone().attr("style",sampleStyle(r,i)),this.parts[n].points.anchor&&(t[n].paths[p+"_"+r]=t[n].paths[p+"_"+r].translate(s,a)),!1!==o&&t[n].paths[p+"_"+r].attributes.add("class",o)}},Pattern.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var e,r=void 0,i=1,o={},n=this.sampleParts(),s=this.config.options[t];if("object"===_typeof(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(i=100),r=s.min/i,e=(s.max/i-r)/9;for(var a=1;a<11;a++)this.settings.options[t]=r,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+round(r)),this.sampleRun(n,o,a,10),r+=e;return this.parts=n,this.runHooks("postSample"),this},Pattern.prototype.sampleListOption=function(t){var e=this.sampleParts(),r=this.config.options[t],i={},o=1,n=r.list.length,s=!0,a=!1,p=void 0;try{for(var h,u=r.list[Symbol.iterator]();!(s=(h=u.next()).done);s=!0){var y=h.value;this.settings.options[t]=y,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+round(y)),this.sampleRun(e,i,o,n),o++}}catch(t){a=!0,p=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw p}}return this.parts=e,this},Pattern.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var e={},r=this.sampleParts(),i=this.settings.measurements[t];if(void 0===i)throw"Cannot sample a measurement that is undefined";var o=i/50;i*=.9;for(var n=1;n<11;n++)this.settings.measurements[t]=i,this.debug("info","🏃🏿‍♀️ Sample run","Sampling measurement "+t+" with value "+round(i)),this.sampleRun(r,e,n,10),i+=o;return this.parts=r,this.runHooks("postSample"),this},Pattern.prototype.sampleModels=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var r={},i=this.sampleParts(),o=0,n=Object.keys(t).length;for(var s in t){o++,this.settings.measurements=t[s],this.debug("info","🏃🏿‍♀️ Sample run","Sampling model "+s);var a=s===e?"sample-focus":"";this.sampleRun(i,r,o,n,a)}return this.parts=i,this.runHooks("postSample"),this},Pattern.prototype.debug=function(){for(var t=arguments.length,e=Array(t),r=0;r<t;r++)e[r]=arguments[r];this.runHooks("debug",e)},Pattern.prototype.render=function(){return this.svg=new Svg(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},Pattern.prototype.on=function(t,e,r){this.hooks[t].push({method:e,data:r})},Pattern.prototype.with=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug("success","🔌 Plugin loaded",t.name+" v"+t.version),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},Pattern.prototype.loadPluginHooks=function(t,e){var r=!0,i=!1,o=void 0;try{for(var n,s=Object.keys(this.hooks)[Symbol.iterator]();!(r=(n=s.next()).done);r=!0){var a=n.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],e);else if("object"===_typeof(t.hooks[a])){var p=!0,h=!1,u=void 0;try{for(var y,f=t.hooks[a][Symbol.iterator]();!(p=(y=f.next()).done);p=!0){var l=y.value;this.on(a,l,e)}}catch(t){h=!0,u=t}finally{try{!p&&f.return&&f.return()}finally{if(h)throw u}}}}}catch(t){i=!0,o=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw o}}},Pattern.prototype.loadPluginMacros=function(t){for(var e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},Pattern.prototype.macro=function(t,e){this.Part.prototype[macroName(t)]=e},Pattern.prototype.pack=function(){var t=[];for(var e in this.parts){var r=this.parts[e];r.attributes.set("transform",""),r.render&&this.needs(e)&&(r.stack(),t.push({id:e,width:r.bottomRight.x-r.topLeft.x,height:r.bottomRight.y-r.topLeft.y}))}var i=pack(t,{inPlace:!0}),o=!0,n=!1,s=void 0;try{for(var a,p=t[Symbol.iterator]();!(o=(a=p.next()).done);o=!0){var h=a.value,u=this.parts[h.id];0===h.x&&0===h.y||u.attr("transform","translate ("+h.x+", "+h.y+")")}}catch(t){n=!0,s=t}finally{try{!o&&p.return&&p.return()}finally{if(n)throw s}}return this.width=i.width,this.height=i.height,this},Pattern.prototype.needs=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if("string"!=typeof t){var r=!0,i=!1,o=void 0;try{for(var n,s=t[Symbol.iterator]();!(r=(n=s.next()).done);r=!0){var a=n.value;if(this.needs(a,e))return!0}}catch(t){i=!0,o=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw o}}return!1}return void 0===this.settings.only?!e:this.settings.only===t||"object"===_typeof(this.settings.only)&&-1!==this.settings.only.indexOf(t)};var index={version:version,Pattern:Pattern,Point:Point,Path:Path,Snippet:Snippet,utils:utils,patterns:{},plugins:{}};module.exports=index;
//# sourceMappingURL=index.js.map
